<?php
//
// Copyright (c) 2008-2011 Nagios Enterprises, LLC.  All rights reserved.
//
// IMPORTANT: SOURCE CODE MAY NOT BE DISCLOSED OR DISTRIBUTED IN UNENCODED FORM
//            WITHOUT EXPLICIT PERMISSION FROM NAGIOS ENTERPRISES.
//  
// $Id: license.php 497 2011-01-21 16:07:46Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);

// only admins can access this page
if(is_admin()==false){
	echo $lstr['NotAuthorizedErrorText'];
	exit();
	}

// route request
route_request();


function route_request(){
	global $request;

	if(isset($request['update']))
		do_update_activation();
	else
		show_activation();
	exit;
	}
	
	
function show_activation($error=false,$msg=""){
	global $request;
	global $lstr;
	
	// get options
	$key=grab_request_var("key");

	do_page_start(array("page_title"=>$lstr['ActivationPageTitle']),true);

?>

	
	<h1><?php echo $lstr['ActivationPageHeader'];?></h1>
	

<?php
	display_message($error,false,$msg);
?>

<?php
	if(is_license_activated()==true){
	//if(0){
?>

	<p>
	Your license is either already activated, or does not require activation.
	</p>

<?php
		}
	else{
?>

	<?php echo $lstr['ActivationPageMessage'];?>
	

	<form id="manageLicenseForm" method="post" action="<?php echo htmlentities($_SERVER['PHP_SELF']);?>">

	
	<input type="hidden" name="update" value="1">
	<?php echo get_nagios_session_protector();?>
	
	<div class="sectionTitle"><?php echo $lstr['ActivationKeySectionTitle'];?></div>

	<table class="manageOptionsTable">
	
	<tr>
	<td>
	<label>License Key:</label><br class="nobr" />
	</td>
	<td>
	<b>
	<?php echo get_license_key();?>
	</b>
	</td>
	</tr>

	<tr>
	<td>
	<label>Server IP Address:</label><br class="nobr" />
	</td>
	<td>
	<b>
	<?php
	$ip=$_SERVER['SERVER_ADDR'];
	echo $ip;
	?>
	</b>
	</td>
	</tr>

	<tr>
	<td>
	<label for="urlBox"><?php echo $lstr['ActivationKeyText'];?>:</label><br class="nobr" />
	</td>
	<td>
<?php
	$keynum=$key;
	if(in_demo_mode()==true)
		$keynum="********";
?>
	<input type="text" size="25" name="key" id="keyBox" value="<?php echo encode_form_val($keynum);?>" class="textfield" /> <a href="http://www.nagios.com/activate/" target="_blank"><b>Get an activation key</b></a><br class="nobr" />
	</td>
	<tr>
	
	</table>

	<div id="formButtons">
	<input type="submit" class="submitbutton" name="updateButton" value="<?php echo $lstr['ActivateKeyButton'];?>" id="updateButton">
	<input type="submit" class="submitbutton" name="cancelButton" value="<?php echo $lstr['CancelButton'];?>" id="cancelButton">
	</div>
	

	<!--</fieldset>-->
	</form>

<?php
		}
?>

<?php

	do_page_end(true);
	exit();
	}


function do_update_activation(){
	global $request;
	global $lstr;
	
	// user pressed the cancel button
	if(isset($request["cancelButton"]))
		header("Location: main.php");
	
		
	// check session
	check_nagios_session_protector();

	$errmsg=array();
	$errors=0;
	
	// get values
	$key=strtoupper(trim(grab_request_var("key","")));

	// make sure we have requirements
	if(in_demo_mode()==true)
		$errmsg[$errors++]=$lstr['DemoModeChangeError'];
	else if($key!="FREE" && is_valid_license_activation_key($key,true)==false){
		$errmsg[$errors++]=$lstr['InvalidActivationKeyError'];
		}

	// update key
	if(in_demo_mode()==false)
		set_option("activation_key",$key);
		
	// handle errors
	if($errors>0)
		show_activation(true,$errmsg);
		
	// success!
	show_activation(false,$lstr['ActivationKeyUpdatedText']);
	}
		
	

?>