<?php
//
// Copyright (c) 2008-2011 Nagios Enterprises, LLC.  All rights reserved.
//
// IMPORTANT: SOURCE CODE MAY NOT BE DISCLOSED OR DISTRIBUTED IN UNENCODED FORM
//            WITHOUT EXPLICIT PERMISSION FROM NAGIOS ENTERPRISES.
//  
// $Id: license.php 566 2011-02-10 14:14:09Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);

// only admins can access this page
if(is_admin()==false){
	echo $lstr['NotAuthorizedErrorText'];
	exit();
	}

// route request
route_request();


function route_request(){
	global $request;

	if(isset($request['update']))
		do_update_license();
	else
		show_license();
	exit;
	}
	
	
function show_license($error=false,$msg=""){
	global $request;
	global $lstr;
	
	// get options
	$key=grab_request_var("key",get_license_key());

	do_page_start(array("page_title"=>$lstr['LicensePageTitle']),true);

?>

	
	<h1><?php echo $lstr['LicensePageTitle'];?></h1>
	

<?php
	display_message($error,false,$msg);
?>

	<?php echo $lstr['LicensePageMessage'];?>
	

	<form id="manageLicenseForm" method="post" action="<?php echo htmlentities($_SERVER['PHP_SELF']);?>">

	
	<input type="hidden" name="update" value="1">
	<?php echo get_nagios_session_protector();?>
	
	<div class="sectionTitle"><?php echo $lstr['LicenseKeySectionTitle'];?></div>

	<table class="manageOptionsTable">

	<tr>
	<td valign="top">
	<label for="urlBox"><?php echo $lstr['LicenseTypeText'];?>:</label><br class="nobr" />
	</td>
	<td>
<?php
	$licensetype="licensed";
	if(is_free_license()==true)
		$licensetype="free";
?>
	<input type="radio" name="licensetype" value="free" <?php echo is_checked($licensetype,"free");?>><?php echo $lstr['LicenseTypeFreeText'];?> <?php echo $lstr['LicenseTypeFreeNotes'];?><br>
	<input type="radio" name="licensetype" value="licensed" <?php echo is_checked($licensetype,"licensed");?>><?php echo $lstr['LicenseTypeLicensedText'];?><br>
	<br class="nobr" />
	</td>
	<tr>

	<tr>
	<td>
	<label for="urlBox"><?php echo $lstr['LicenseKeyText'];?>:</label><br class="nobr" />
	</td>
	<td>
<?php
	$keynum=$key;
	if(in_demo_mode()==true)
		$keynum="********";
?>
	<input type="text" size="45" name="key" id="keyBox" value="<?php echo encode_form_val($keynum);?>" class="textfield" /><br class="nobr" />
	</td>
	<tr>
	
	</table>

	<div class="sectionTitle"><?php echo $lstr['LicenseInformationSectionTitle'];?></div>

	<table class="licenseInfoTable">
	<?php echo get_license_info($key);?>
	</table>

	<div class="sectionTitle"><?php echo $lstr['LicenseActivationSectionTitle'];?></div>
	
	<table class="licenseActivationTable">
	<?php
	$is_activated=is_license_activated();
	if($is_activated==true){
	?>
	<tr><td>Activation Status:</td><td>Activated</td></tr>
	<?php
		}
	else{
	?>
	<tr><td>Activation Status:</td><td><b>Not Activated</b>  <a href="activate.php">Activate your license key</a></td></tr>
	<?php
		}
	?>
	</table>

	<div id="formButtons">
	<input type="submit" class="submitbutton" name="updateButton" value="<?php echo $lstr['UpdateKeyButton'];?>" id="updateButton">
	<input type="submit" class="submitbutton" name="cancelButton" value="<?php echo $lstr['CancelButton'];?>" id="cancelButton">
	</div>
	

	<!--</fieldset>-->
	</form>


<?php

	do_page_end(true);
	exit();
	}


function do_update_license(){
	global $request;
	global $lstr;
	
	// user pressed the cancel button
	if(isset($request["cancelButton"]))
		header("Location: main.php");
	
		
	// check session
	check_nagios_session_protector();

	$errmsg=array();
	$errors=0;
	
	// get values
	$licensetype=grab_request_var("licensetype");
	if($licensetype=="free"){
		$request["key"]="FREE";
		}
	else if($request["key"]=="FREE"){
		$request["key"]="";
		}
	$key=strtoupper(trim(grab_request_var("key","")));

	// make sure we have requirements
	if(in_demo_mode()==true)
		$errmsg[$errors++]=$lstr['DemoModeChangeError'];
	else if($key!="FREE" && is_valid_license_key($key)==false){
		$errmsg[$errors++]=$lstr['InvalidLicenseKeyError'];
		}

	// update key
	if(in_demo_mode()==false)
		set_option("license_key",$key);
		
	// handle errors
	if($errors>0)
		show_license(true,$errmsg);
		
	// success!
	show_license(false,$lstr['LicenseInformationUpdatedText']);
	}
		
	

?>