<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// Development Started 03/22/2008
// $Id: utils-commands.inc.php 75 2010-04-01 19:40:08Z egalstad $

//require_once(dirname(__FILE__).'/common.inc.php');



///////////////////////////////////////////////////////////////////////////////////////////
//
// LOW-LEVEL COMMANDS
//
///////////////////////////////////////////////////////////////////////////////////////////

function submit_command($command,$command_data="",$event_time=0,$submitter_id=0,$args=null){
	global $db_tables;
	
	// use logged in user's id
	if($submitter_id==0 && isset($_SESSION["user_id"]))
		$submitter_id=$_SESSION["user_id"];
		
	// make sure user is authorized to submit command
	if(is_authorized_to_submit_command($command,$command_data,$args)==false){
		return -2;
		}

	$timestring=sql_time_from_timestamp($event_time,DB_NAGIOSXI);
	
	$sql="INSERT INTO ".$db_tables[DB_NAGIOSXI]["commands"]." (submitter_id,command,command_data,event_time,submission_time,status_code) VALUES ('".escape_sql_param($submitter_id,DB_NAGIOSXI)."','".escape_sql_param($command,DB_NAGIOSXI)."','".escape_sql_param($command_data,DB_NAGIOSXI)."',".$timestring.",NOW(),'".escape_sql_param(COMMAND_STATUS_QUEUED,DB_NAGIOSXI)."')";
	//echo "SQL: $sql<BR>\n";
	$rs=exec_sql_query(DB_NAGIOSXI,$sql);
	if(!$rs)
		$command_id=-1;
	else
		$command_id=get_sql_insert_id(DB_NAGIOSXI,"xi_commands_command_id_seq");
	
	return $command_id;
	}

	
function is_authorized_to_submit_command($command,$command_data,$args){

	// subsystem can do anything
	if(defined("SUBSYSTEM")==true)
		return true;
	if(defined("SUBSYSTEM_CALL")==true)
		return true;
	
	// admins can do anything
	if(is_admin()==true)
		return true;
		
	// TODO - check perms for non-admins...
	
	$auth_system=is_authorized_for_monitoring_system();
	$auth_objects=is_authorized_for_all_objects();
	$auth_objectcommands=is_authorized_for_all_object_commands();
	
	$auth=false;
	
	switch($command){
		case COMMAND_NAGIOSCORE_SUBMITCOMMAND:
			if($auth_system || $auth_objectcommands)
				$auth=true;
			// check for host/service-specific permissions
			// command data  is serialized so decode it...
			$cmdarr=unserialize($command_data);
			$host="";
			$service="";
			if(array_key_exists("host_name",$cmdarr))
				$host=$cmdarr["host_name"];
			if(array_key_exists("service_name",$cmdarr))
				$service=$cmdarr["service_name"];
			if($host!=""){
				if($service!=""){
					if(is_authorized_for_service(0,$host,$service,P_EXECUTE)==true)
						$auth=true;
					}
				else{
					if(is_authorized_for_host(0,$host,P_EXECUTE)==true)
						$auth=true;
					}
				}
			break;
		case COMMAND_NAGIOSCORE_START:
		case COMMAND_NAGIOSCORE_STOP:
		case COMMAND_NAGIOSCORE_RESTART:
			if($auth_system)
				$auth=true;
			break;
		default:
			$auth=true;  // by default, allow other commands that we don't know about yet, or that don't require auth checks
			break;
		}
		
	if($auth==true)
		return true;
		
	return false;
	}

?>