<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// Development Started 03/22/2008
// $Id: utils-dashlets.inc.php 514 2011-01-29 15:53:15Z egalstad $

//require_once(dirname(__FILE__).'/common.inc.php');



////////////////////////////////////////////////////////////////////////
// DASHLET  FUNCTIONS
////////////////////////////////////////////////////////////////////////

function register_dashlet($name="",$args=null){
	global $dashlets;
	
	
	if($name=="")
		return false;
	
	if(!isset($dashlets)){
		//echo "SETTING DASHLETS ARRAY!<BR>\n";
		$dashlets=array();
		}
	
	//echo "REGISTERING: $name<BR>";
		
	$dashlets[$name]=$args;
	
	return true;
	}

	
function get_dashlet_url_base($name){
	$url=get_base_url()."/includes/dashlets/".$name;
	return $url;
	}

function get_dashlet_dir_base($name){
	$url=get_base_dir()."/includes/dashlets/".$name;
	return $url;
	}	
	
function get_dashlets_pagepart_includes(){
	global $dashlets;
	
	$html="";
	foreach($dashlets as $d){
		$html.=get_dashlet_pagepart_includes($d);
		}
	return $html;
	}
	
function get_dashlet_pagepart_includes($d){

	$url=get_base_url()."includes/dashlets/".$d[DASHLET_NAME]."/";
	$html="";

	// include css file
	if(array_key_exists(DASHLET_CSS_FILE,$d)==true)
		$html.="<link rel='stylesheet' type='text/css' href='".$url.$d[DASHLET_CSS_FILE]."' />\n";

	// include js file
	if(array_key_exists(DASHLET_JS_FILE,$d)==true)
		$html.="<script type='text/javascript' src='".$url.$d[DASHLET_JS_FILE]."'></script>\n";

	return $html;
	}
	

function get_dashlet_by_name($name=""){
	global $dashlets;
	
	$dashlet=null;

	if($name=="")
		return null;
		
	// "normal", user dashlets
	if(!array_key_exists($name,$dashlets))
		return null;
	$dashlet=$dashlets[$name];
		
	return $dashlet;
	}
	
// used for previews and outboard displays of dashlet
function display_dashlet($name="",$id="",$args=null,$mode=DASHLET_MODE_PREVIEW){
	if($mode!=DASHLET_MODE_INBOARD)
		display_dashlet1($name,$id,$args,$mode);
	else
		display_dashlet2($name,$id,$args,$mode);
	}
	
// outboard and preview modes
function display_dashlet1($name="",$id="",$args=null,$mode=DASHLET_MODE_PREVIEW){

	$d=get_dashlet_by_name($name);
	if($d==null)
		return;
		
	if($args==null)
		$args=array();

	$dashlet_args=array();

	// star the magic dashletify output code...
	$dashletifyargs=array(
		DASHLET_NAME => $name, //<!-- need this in two places
		);
		
	// get inboard/outboard/preview class from the dashlet definition
	switch($mode){
		case DASHLET_MODE_OUTBOARD:
			if(array_key_exists(DASHLET_OUTBOARD_CLASS,$d))
				$dashletifyargs[DASHLET_CLASS]=$d[DASHLET_OUTBOARD_CLASS];
			break;
		case DASHLET_MODE_PREVIEW:
			if(array_key_exists(DASHLET_PREVIEW_CLASS,$d))
				$dashletifyargs[DASHLET_CLASS]=$d[DASHLET_PREVIEW_CLASS];
			break;
		default:
			break;
		}

	if(array_key_exists(DASHLET_ADDTODASHBOARDTITLE,$d))
		$dashletifyargs[DASHLET_ADDTODASHBOARDTITLE]=$d[DASHLET_ADDTODASHBOARDTITLE];
	if(array_key_exists(DASHLET_TITLE,$d))
		$dashletifyargs[DASHLET_TITLE]=$d[DASHLET_TITLE];
		
	// get overridden values that were passed to us
	// VARS USED ONLY IN DASHLETIFY FUNCTIONS...
	if(array_key_exists(DASHLET_CLASS,$args)){
		$dashletifyargs[DASHLET_CLASS].=" ".$args[DASHLET_CLASS];
		//unset($args[DASHLET_CLASS]);
		}
	if(array_key_exists(DASHLET_ADDTODASHBOARDTITLE,$args)){
		$dashletifyargs[DASHLET_ADDTODASHBOARDTITLE]=$args[DASHLET_ADDTODASHBOARDTITLE];
		//unset($args[DASHLET_ADDTODASHBOARDTITLE]);
		}
	if(array_key_exists(DASHLET_TITLE,$args)){
		$dashletifyargs[DASHLET_TITLE]=$args[DASHLET_TITLE];
		//unset($args[DASHLET_TITLE]);
		}
		
	// dashlet args
	if(array_key_exists(DASHLET_ARGS,$args))
		$dashlet_args=$args[DASHLET_ARGS];
		
	$dashletifyargs[DASHLET_ARGS]=$dashlet_args;


	// dashletify it!
	dashletify_begin($dashletifyargs);

	// get the output from the dashlet function
	if(array_key_exists(DASHLET_FUNCTION,$d)){
		$output=get_dashlet_output($name,$id,$mode,$dashlet_args);
		echo $output;
		}
	// embed the dashlet url
	else if(array_key_exists(DASHLET_URL,$d)){
	
		// preview mode of url should show an image
		if($mode==DASHLET_MODE_PREVIEW){
			if(array_key_exists(DASHLET_PREVIEW_IMAGE,$d)){
				$output="<IMG SRC='".$d[DASHLET_PREVIEW_IMAGE]."'>";
				}
			else
				$output="NO PREVIEW IMAGE";
			}
		
		// normal display of url dashlets...
		else{

			$output="";
			$url=$d[DASHLET_URL];

			$output='<IFRAME src="'.$url.'" width="'.$args["iframe_width"].'px"  height="'.$args["iframe_height"].'px" frameborder="0" id="dashlet-'.$id.'-iframe-id" name="dashlet-'.$id.'-iframe">
		[Your user agent does not support frames or is currently configured not to display frames. ]
		</IFRAME>';
			}
			
		echo $output;
		}
	// get the dashlet html
	else if(array_key_exists(DASHLET_HTML,$d)){
		$output=$d[DASHLET_HTML];
		echo $output;
		}
		
	// the fun is done
	dashletify_end();
	}


// used for inboard displays of dashlet
function display_dashlet2($name="",$id="",$args=null,$mode=DASHLET_MODE_PREVIEW){
	
	//echo "NAME: $name, ID: $id, MODE: $mode<BR>";
	//return;
	
	$d=get_dashlet_by_name($name);
	if($d==null)
		return;
		
	if($args==null)
		$args=array();


	// get the output from the dashlet function
	if(array_key_exists(DASHLET_FUNCTION,$d)){
		$output=get_dashlet_output($name,$id,$mode,$args);
		echo $output;
		}
	// embed the dashlet url
	if(array_key_exists(DASHLET_URL,$d)){
	
		// preview mode of url should show an image
		if($mode==DASHLET_MODE_PREVIEW){
			if(array_key_exists(DASHLET_PREVIEW_IMAGE,$d)){
				$output="<IMG SRC='".$d[DASHLET_PREVIEW_IMAGE]."'>";
				}
			else
				$output="NO PREVIEW IMAGE";
			}
		
		// normal display of url dashlets...
		else{

			$output="";
			$url=$d[DASHLET_URL];

			//echo "URL!";
			//echo $url;
			//print_r($d);

			$output='<IFRAME src="'.$url.'" width="'.$args["iframe_width"].'px"  height="'.$args["iframe_height"].'px" frameborder="0" id="dashlet-'.$id.'-iframe-id" name="dashlet-'.$id.'-iframe">
		[Your user agent does not support frames or is currently configured not to display frames. ]
		</IFRAME>';
			}
			
		echo $output;
		}
	// get the dashlet html
	if(array_key_exists(DASHLET_HTML,$d)){
		$output=$d[DASHLET_HTML];
		echo $output;
		}
			
	return;
	}
	
function get_dashlet_output($name="",$id="",$mode=DASHLET_MODE_PREVIEW,$args=null){
	
	// USE THIS FOR DEBUGGING!
	//return "<BR>NAME: $name, ID: $id, MODE: $mode, ARGS: ".serialize($args)."<BR>";
	
	$d=get_dashlet_by_name($name);
	if($d==null)
		return "";
		
	$output="";
	//$output="NO DASHLET FUNCTION OUTPUT";
		
	// run the dashlet function
	if(array_key_exists(DASHLET_FUNCTION,$d) && have_value($d[DASHLET_FUNCTION])==true){
		$f=$d[DASHLET_FUNCTION];
		if(function_exists($f))
			$output=$f($mode,$id,$args);
		else
			$output="DASHLET FUNCTION '".$f."' DOES NOT EXIST";
		}
	// nothing to do...
	else
		return $output;
		
	return $output;
	}


// get refresh rate for a particular dashlet
function get_dashlet_refresh_rate($rate=60,$name="default_dashlet",$raw=false){
	global $cfg;

	// use saved option if possible
	$option=get_option($name."_dashlet_refresh_rate");
	if($option!=""){
		$r=$option;
		//echo "FOUND RATE<BR>";
		}

	else{
	
		//echo "NO RATE FOUND<BR>";

		// use option from config file (if it exists)
		if(array_key_exists("dashlet_refresh_rates",$cfg)){
			$r=grab_array_var($cfg["dashlet_refresh_rates"],$name,$rate);
			}
			
		// else use default that was passed to us
		else
			$r=$rate;
		}

	if($raw==true)
		$therate=$r;
	else{
		// get the multiplier
		$m=get_dashlet_refresh_multiplier(1000);
		$therate=$r*$m;
		}

	return $therate;
	}
	
function set_dashlet_refresh_rate($rate=60,$name="default_dashlet"){
	$optname=$name."_dashlet_refresh_rate";
	set_option($optname,$rate);
	//echo "SET $optname = $rate<BR>";
	}
	
function get_dashlet_refresh_multiplier($multiplier=1000){
	global $cfg;

	// use saved option if possible
	$option=get_option("dashlet_refresh_multiplier");
	if($option!="")
		$m=$option;

	else{

		// get default from config file (use specified value if it doesn't exist)
		$m=grab_array_var($cfg,"dashlet_refresh_multiplier",$multiplier);
		}

	return $m;
	}
	
function set_dashlet_refresh_multiplier($multiplier=1000){
	set_option("dashlet_refresh_multiplier",$multiplier);
	}


////////////////////////////////////////////////////////////////////////
// DASHLETIFY FUNCTIONS
////////////////////////////////////////////////////////////////////////

function dashletify_begin($dargs=null){

	//print_r($dargs);
	//return;
	
	if($dargs==null)
		$dargs=array();

	$class="";
	$buttontitle="Add This To A Dashboard";
	$args=array();
	$style="";
	
	$args=array();
	
	if(array_key_exists(DASHLET_CLASS,$dargs))
		$class=$dargs[DASHLET_CLASS];
	if(array_key_exists(DASHLET_ADDTODASHBOARDTITLE,$dargs))
		$buttontitle=$dargs[DASHLET_ADDTODASHBOARDTITLE];

	// STUFF TO PASS ON
	if(array_key_exists(DASHLET_NAME,$dargs))
		$dashletaddargs[DASHLET_NAME]=$dargs[DASHLET_NAME];
	if(array_key_exists(DASHLET_TITLE,$dargs))
		$dashletaddargs[DASHLET_TITLE]=$dargs[DASHLET_TITLE];
	if(array_key_exists(DASHLET_ARGS,$dargs))
		$dashletaddargs[DASHLET_ARGS]=$dargs[DASHLET_ARGS];
		
	
	if($buttontitle!="")
		$buttontitlespace=" ";
	echo "<div class='dashlettable ".$class."'>";
	echo "<div class='dashifybutton'><a class='dashifybutton' href='#' title='".$buttontitle."'><img src='".theme_image("dashify.png")."'></a></div>";
	echo "<div class='dashlettablecontentargs'>";
	//print_r($args);
	echo base64_encode(serialize($dashletaddargs));
	echo "</div>";
	//echo "<BR>\n<div class='dashlettablecontentargs-debug'><BR>\n";
	//print_r($dashletaddargs);
	//echo "\n<BR></div>";
	echo "<div class='dashlettableinnercontent ".$class."'";
	if($style!="")
		echo" style='".$style."'";
	echo ">";
	}
	
function dashletify_end($opts=""){
	echo "</div>";
	echo "</div>";
	}


////////////////////////////////////////////////////////////////////////
// DASHLET PREVIEW FUNCTIONS
////////////////////////////////////////////////////////////////////////

// displays a single available dashlet
function display_dashlet_preview($name,$darray){

	// some dashlets shouldn't show in the preview
	if(array_key_exists(DASHLET_SHOWASAVAILABLE,$darray)){
		if($darray[DASHLET_SHOWASAVAILABLE]==false)
			return;
		}
		
	// TODO - check dashlet perms to make sure this user can see/use the dashlet
	
	
	// TODO - check to make sure all required dashlet components are installed/enabled


	//print_r($d);
	$s="";
	if(array_key_exists(DASHLET_DESCRIPTION,$darray))
		$s.="<b>".$darray[DASHLET_DESCRIPTION]."</b><br> ";
	if(array_key_exists(DASHLET_VERSION,$darray))
		$s.="Version: ".$darray[DASHLET_VERSION]."   ";
	if(array_key_exists(DASHLET_DATE,$darray))
		$s.="Date: ".$darray[DASHLET_DATE]."   ";
	if(array_key_exists(DASHLET_AUTHOR,$darray))
		$s.="Author: ".$darray[DASHLET_AUTHOR]."  ";
	if(array_key_exists(DASHLET_COPYRIGHT,$darray))
		$s.="".$darray[DASHLET_COPYRIGHT]."  ";
	if(array_key_exists(DASHLET_HOMEPAGE,$darray))
		$s.="Website: <a href='".$darray[DASHLET_HOMEPAGE]."' target='_blank'>".$darray[DASHLET_HOMEPAGE]."</a> ";
		
	$args=array();
	// pass iframe dimensions to URL dashlets
	if(array_key_exists(DASHLET_WIDTH,$darray))
		$args["iframe_width"]=$darray[DASHLET_WIDTH];
	if(array_key_exists(DASHLET_HEIGHT,$darray))
		$args["iframe_height"]=$darray[DASHLET_HEIGHT];
	
	if(array_key_exists(DASHLET_TITLE,$darray))
		$title=$darray[DASHLET_TITLE];
	else
		$title=$name;
		
?>
	<div class="availabledashlet">
	<div class="name"><?php echo $title;?></div>
	<div class="thedashlet">
	<?php display_dashlet($name,"",$args,DASHLET_MODE_PREVIEW);?>
	</div>
	<div class="about"><?php echo $s;?></div>
	</div>
<?php	
	}

?>