<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// Development Started 03/22/2008
// $Id: utils-nagioscore.inc.php 321 2010-09-27 16:34:01Z egalstad $

//require_once(dirname(__FILE__).'/common.inc.php');



///////////////////////////////////////////////////////////////////////////////////////////
//
// LOW-LEVEL NAGIOS CORE COMMAND FUNCTIONS
//
///////////////////////////////////////////////////////////////////////////////////////////

function submit_direct_nagioscore_command($raw_command,&$output){
	global $cfg;
	
	$output="";

	// TODO!
	// make sure nagios is running - see homi code

	// get command file location
	$command_file=$cfg['component_info']['nagioscore']['cmd_file'];
	
	if(file_exists($command_file)==false){
		$output="ERROR: Command file does not exist";
		return false;
		}
		
	if(($fp=@fopen($command_file,"w"))==false){
		$output="ERROR: Could not open command file";
		return false;
		}
	$now=time();
	$command=sprintf("[%lu] %s\n",$now,$raw_command);
	fputs($fp,$command);
	fclose($fp);
	
	$output="Command submitted";
	
	return true;
	}

function get_nagioscore_command_name($command_id){
	global $nagioscore_cmd_strings;
	
	if(array_key_exists($command_id,$nagioscore_cmd_strings))
		return $nagioscore_cmd_strings[$command_id];
	else
		return "";
	}
	
function get_nagioscore_command($command_id,$args=null){

	$output="";
	
	// initialize some vars
	$host_name=grab_array_var($args,"host_name","");
	$service_name=grab_array_var($args,"service_name","");
	$persistent_comment=grab_array_var($args,"persistent_comment",1);
	$comment_id=grab_array_var($args,"comment_id",-1);
	$comment_author=grab_array_var($args,"comment_author","");
	$comment_data=grab_array_var($args,"comment_data","");
	$notification_time=grab_array_var($args,"notification_time","");
	$start_time=grab_array_var($args,"start_time","");
	$end_time=grab_array_var($args,"end_time","");
	$scheduled_time=grab_array_var($args,"scheduled_time","");

	switch($command_id){

		// no argument
		case NAGIOSCORE_CMD_START_EXECUTING_SVC_CHECKS:
		case NAGIOSCORE_CMD_STOP_EXECUTING_SVC_CHECKS:
		case NAGIOSCORE_CMD_START_ACCEPTING_PASSIVE_SVC_CHECKS:
		case NAGIOSCORE_CMD_STOP_ACCEPTING_PASSIVE_SVC_CHECKS:
		case NAGIOSCORE_CMD_ENABLE_EVENT_HANDLERS:
		case NAGIOSCORE_CMD_DISABLE_EVENT_HANDLERS:
		case NAGIOSCORE_CMD_START_OBSESSING_OVER_SVC_CHECKS:
		case NAGIOSCORE_CMD_STOP_OBSESSING_OVER_SVC_CHECKS:
		case NAGIOSCORE_CMD_ENABLE_FLAP_DETECTION:
		case NAGIOSCORE_CMD_DISABLE_FLAP_DETECTION:
		case NAGIOSCORE_CMD_ENABLE_FAILURE_PREDICTION:
		case NAGIOSCORE_CMD_DISABLE_FAILURE_PREDICTION:
		case NAGIOSCORE_CMD_ENABLE_PERFORMANCE_DATA:
		case NAGIOSCORE_CMD_DISABLE_PERFORMANCE_DATA:
		case NAGIOSCORE_CMD_START_EXECUTING_HOST_CHECKS:
		case NAGIOSCORE_CMD_STOP_EXECUTING_HOST_CHECKS:
		case NAGIOSCORE_CMD_START_ACCEPTING_PASSIVE_HOST_CHECKS:
		case NAGIOSCORE_CMD_STOP_ACCEPTING_PASSIVE_HOST_CHECKS:
		case NAGIOSCORE_CMD_START_OBSESSING_OVER_HOST_CHECKS:
		case NAGIOSCORE_CMD_STOP_OBSESSING_OVER_HOST_CHECKS:
			$output=get_nagioscore_command_name($command_id);
			break;

		// simple host commands
		case NAGIOSCORE_CMD_ENABLE_HOST_FLAP_DETECTION:
		case NAGIOSCORE_CMD_DISABLE_HOST_FLAP_DETECTION:
		case NAGIOSCORE_CMD_ENABLE_PASSIVE_HOST_CHECKS:
		case NAGIOSCORE_CMD_DISABLE_PASSIVE_HOST_CHECKS:
		case NAGIOSCORE_CMD_START_OBSESSING_OVER_HOST:
		case NAGIOSCORE_CMD_STOP_OBSESSING_OVER_HOST:
		case NAGIOSCORE_CMD_DEL_ALL_HOST_COMMENTS:
		case NAGIOSCORE_CMD_ENABLE_ALL_NOTIFICATIONS_BEYOND_HOST:
		case NAGIOSCORE_CMD_DISABLE_ALL_NOTIFICATIONS_BEYOND_HOST:
		case NAGIOSCORE_CMD_ENABLE_HOST_EVENT_HANDLER:
		case NAGIOSCORE_CMD_DISABLE_HOST_EVENT_HANDLER:
		case NAGIOSCORE_CMD_ENABLE_HOST_NOTIFICATIONS:
		case NAGIOSCORE_CMD_DISABLE_HOST_NOTIFICATIONS:
		case NAGIOSCORE_CMD_ENABLE_HOST_CHECK:
		case NAGIOSCORE_CMD_DISABLE_HOST_CHECK:
		case NAGIOSCORE_CMD_REMOVE_HOST_ACKNOWLEDGEMENT:
			$output=sprintf("%s;%s",get_nagioscore_command_name($command_id),$host_name);

			break;

		case NAGIOSCORE_CMD_SCHEDULE_HOST_CHECK:
		case NAGIOSCORE_CMD_SCHEDULE_FORCED_HOST_CHECK:
			$output=sprintf("%s;%s;%lu",get_nagioscore_command_name($command_id),$host_name,$start_time);
			break;

		// simple service commands
		case NAGIOSCORE_CMD_ENABLE_SVC_FLAP_DETECTION:
		case NAGIOSCORE_CMD_DISABLE_SVC_FLAP_DETECTION:
		case NAGIOSCORE_CMD_ENABLE_PASSIVE_SVC_CHECKS:
		case NAGIOSCORE_CMD_DISABLE_PASSIVE_SVC_CHECKS:
		case NAGIOSCORE_CMD_START_OBSESSING_OVER_SVC:
		case NAGIOSCORE_CMD_STOP_OBSESSING_OVER_SVC:
		case NAGIOSCORE_CMD_DEL_ALL_SVC_COMMENTS:
		case NAGIOSCORE_CMD_ENABLE_SVC_NOTIFICATIONS:
		case NAGIOSCORE_CMD_DISABLE_SVC_NOTIFICATIONS:
		case NAGIOSCORE_CMD_ENABLE_SVC_EVENT_HANDLER:
		case NAGIOSCORE_CMD_DISABLE_SVC_EVENT_HANDLER:
		case NAGIOSCORE_CMD_ENABLE_SVC_CHECK:
		case NAGIOSCORE_CMD_DISABLE_SVC_CHECK:
		case NAGIOSCORE_CMD_REMOVE_SVC_ACKNOWLEDGEMENT:
			$output=sprintf("%s;%s;%s",get_nagioscore_command_name($command_id),$host_name,$service_name);
			break;
			
		case NAGIOSCORE_CMD_ADD_HOST_COMMENT:
			$output=sprintf("%s;%s;%d;%s;%s",get_nagioscore_command_name($command_id),$host_name,$persistent_comment,$comment_author,$comment_data);
			break;

		case NAGIOSCORE_CMD_ADD_SVC_COMMENT:
			$output=sprintf("%s;%s;%s;%d;%s;%s",get_nagioscore_command_name($command_id),$host_name,$service_name,$persistent_comment,$comment_author,$comment_data);
			break;

		case NAGIOSCORE_CMD_DEL_HOST_COMMENT:
		case NAGIOSCORE_CMD_DEL_SVC_COMMENT:
			$output=sprintf("%s;%lu",get_nagioscore_command_name($command_id),$comment_id);
			break;
			
		case NAGIOSCORE_CMD_DELAY_HOST_NOTIFICATION:
			$output=sprintf("%s;%s;%lu",get_nagioscore_command_name($command_id),$host_name,$notification_time);
			break;

		case NAGIOSCORE_CMD_DELAY_SVC_NOTIFICATION:
			$output=sprintf("%s;%s;%s;%lu",get_nagioscore_command_name($command_id),$host_name,$service_name,$notification_time);
			break;

		case NAGIOSCORE_CMD_SCHEDULE_SVC_CHECK:
		case NAGIOSCORE_CMD_SCHEDULE_FORCED_SVC_CHECK:
			$output=sprintf("%s;%s;%s;%lu",get_nagioscore_command_name($command_id),$host_name,$service_name,$start_time);
			break;

		case NAGIOSCORE_CMD_DISABLE_NOTIFICATIONS:
		case NAGIOSCORE_CMD_ENABLE_NOTIFICATIONS:
		case NAGIOSCORE_CMD_SHUTDOWN_PROCESS:
		case NAGIOSCORE_CMD_RESTART_PROCESS:
			$output=sprintf("%s;%lu",get_nagioscore_command_name($command_id),$scheduled_time);
			break;

			
		/*
		case NAGIOSCORE_CMD_ENABLE_HOST_SVC_CHECKS:
		
		ETC...
		*/

		default:
			$output="";
			break;
		}
			
	return $output;
	}
	
	

///////////////////////////////////////////////////////////////////////////////////////////
//
// NAGIOS CORE CONFIGURATION COMMANDS
//
///////////////////////////////////////////////////////////////////////////////////////////

function reconfigure_nagioscore(){
	$id=submit_command(COMMAND_NAGIOSCORE_RECONFIGURE);
	return $id;
	}
	
function create_nagioscore_import_file(&$fname){
	global $cfg;

	$dir=$cfg['component_info']["nagioscore"]["import_dir"];
	
	// generate a temporary filename
	if($fname==""){
		$rand=random_string(8);
		$fname=$dir."/".$rand.".tmp";
		}
	else{
		$fn=$dir."/".$fname;
		$fname=$fn;
		}
	
	// open the file
	$fh=fopen($fname,"a+");
	
	return $fh;
	}
	
function close_nagioscore_import_file($fh){
	fclose($fh);
	}
	
function commit_nagioscore_import_file($fname){

	// append a ".cfg" extension to the temp import file
	$newfname=$fname.".cfg";
	
	// set permissions on file so it can be deleted
	chmod($fname,0664);
	
	// rename the file
	rename($fname,$newfname);
	
	// set permissions on file so it can be deleted
	chmod($newfname,0664);

	// reconfigure nagios
	//reconfigure_nagioscore();
	}


///////////////////////////////////////////////////////////////////////////////////////////
//
// NAGIOS CORE OBJECT COMMANDS
//
///////////////////////////////////////////////////////////////////////////////////////////

function add_nagioscore_contact($args,$reconfigure=true){

	// make sure we have the requirements
	if(!array_key_exists("contact_name",$args))
		return false;
	if(!array_key_exists("email",$args))
		return false;
		
	// get values
	$contact_name=grab_array_var($args,"contact_name","");
	$alias=grab_array_var($args,"alias","");
	$email=grab_array_var($args,"email","");
		
	$fname="";
	$fh=create_nagioscore_import_file($fname);
	//echo "FNAME: $fname";
	
	$tperiod_name=$contact_name."_notification_times";

	// add a notification timeperiod for the contact
	fprintf($fh,"define timeperiod{\n");
	fprintf($fh,"timeperiod_name\t%s\n",$tperiod_name);
	fprintf($fh,"alias\tNotification Times for %s\n",$contact_name);
	fprintf($fh,"monday\t00:00-24:00\n");
	fprintf($fh,"tuesday\t00:00-24:00\n");
	fprintf($fh,"wednesday\t00:00-24:00\n");
	fprintf($fh,"thursday\t00:00-24:00\n");
	fprintf($fh,"friday\t00:00-24:00\n");
	fprintf($fh,"saturday\t00:00-24:00\n");
	fprintf($fh,"sunday\t00:00-24:00\n");
	fprintf($fh,"}\n");

	// add the contact
	fprintf($fh,"define contact{\n");
	fprintf($fh,"use\txi_contact_generic\n");
	fprintf($fh,"contact_name\t%s\n",$contact_name);
	if($alias!=null)
		fprintf($fh,"alias\t%s\n",$alias);
	fprintf($fh,"host_notification_period\t%s\n",$tperiod_name);
	fprintf($fh,"service_notification_period\t%s\n",$tperiod_name);
	fprintf($fh,"host_notifications_enabled\t1\n");
	fprintf($fh,"service_notifications_enabled\t1\n");
	fprintf($fh,"host_notification_options\td,u,r,f,s\n");
	fprintf($fh,"service_notification_options\tw,u,c,r,f,s\n");
	fprintf($fh,"email\t%s\n",$email);
	if($alias!="")
		fprintf($fh,"alias\t%s\n",$alias);
	fprintf($fh,"}\n");
	
	fclose($fh);
	commit_nagioscore_import_file($fname);	
	if($reconfigure==true)
		reconfigure_nagioscore();
	}
	
	
function delete_nagioscore_contact($contactname,$reconfigure=true){

	$id=nagiosql_get_contact_id($contactname);
	//echo "CONTACT: $contactname\n";
	//echo "CONTACTID: $id\n";
	if($id>0)
		submit_command(COMMAND_NAGIOSQL_DELETECONTACT,$id);

	// delete the associated timeperiod
	$timeperiodname=get_nagioscore_contact_timeperiod_name($contactname);
	//echo "TIMEPERIOD: $timeperiodname\n";
	$tid=nagiosql_get_timeperiod_id($timeperiodname);
	//echo "TIMEPERIODID: $tid\n";
	if($tid>0)
		submit_command(COMMAND_NAGIOSQL_DELETETIMEPERIOD,$tid);
		
	//exit();
		
	if($reconfigure==true)
		reconfigure_nagioscore();
	}
	
function update_nagioscore_contact($contactname,$args,$reconfigure=true){
	$id=nagiosql_get_contact_id($contactname);
	nagiosql_update_contact($id,$args);
	if($reconfigure==true)
		reconfigure_nagioscore();
	}
	
function rename_nagioscore_contact($oldname,$newname,$reconfigure=true){

	// rename the contact
	nagiosql_rename_contact($oldname,$newname);

	// rename the contact's timeperiod
	$oldtp=get_nagioscore_contact_timeperiod_name($oldname);
	$newtp=get_nagioscore_contact_timeperiod_name($newname);
	nagiosql_rename_timeperiod($oldtp,$newtp);

	if($reconfigure==true)
		reconfigure_nagioscore();
	}
	

function get_nagioscore_contact_timeperiod_name($contactname){
	$timeperiodname=$contactname."_notification_times";
	return $timeperiodname;
	}

function update_nagioscore_timeperiod_times($timeperiodname,$definition,$args,$reconfigure=true){
	$id=nagiosql_get_timeperiod_id($timeperiodname);
	nagiosql_update_timeperiod_times($id,$definition,$args);
	if($reconfigure==true)
		reconfigure_nagioscore();
	}
	
	
function get_user_nagioscore_contact_info($username){

	$arr=array(
		"is_nagioscore_contact" => false,  // is the user a Nagios Core contact?
		"has_nagiosxi_timeperiod" => false, // does the contact have XI notification timeperiod?
		"has_nagiosxi_commands" => false, // does the contact have XI notification commands?
		);
		
	// see if user is a contact
	$cid=nagiosql_get_contact_id($username);
	if($cid>0){

		$arr["is_nagioscore_contact"]=true;
		
		// get contact database record fields
		$rsf=nagiosql_get_contact_record($username);
		
		//print_r($rsf);
		
		// see if contact uses xi host/service notification timeperiods
		$tpname=get_nagioscore_contact_timeperiod_name($username);
		$tpid=nagiosql_get_timeperiod_id($tpname);
		
		//echo "<BR>TPNAME=$tpname, TPID=$tpid<BR>";
		
		if($tpid>0 && $rsf!=null){
			if($rsf["host_notification_period"]==$tpid && $rsf["service_notification_period"]==$tpid)
				$arr["has_nagiosxi_timeperiod"]=true;
			}
			
		// see if contact uses xi host/service notification commands
		// TODO - assume yes for time being
		// TODO - check to make sure contact either has commands in definition, or through inheritance from a template
		// TODO - it might be easier to just check "resolved" config from NDOUtils
		// NOTE - there is a bug in NDOUtils - the contact_notification_commands table has incorrect values for the command object id, so we can't use it
		
		/*
		$hncid=get_object_id(OBJECTTYPE_COMMAND,"xi_host_notification_handler",null);
		$sncid=get_object_id(OBJECTTYPE_COMMAND,"xi_service_notification_handler",null);

		$coid=get_object_id(OBJECTTYPE_CONTACT,$username,null);
		$cid=get_object_id(OBJECTTYPE_CONTACT,$username,null);

		echo "HNCID=$hncid, SNCID=$sncid<BR>";
		echo "COID=$cid<BR>";
		echo "COID=$cid<BR>";
		*/
		
		// assume commands are okay if we have a contact
		$arr["has_nagiosxi_commands"]=true;
		}
		
	return $arr;
	}
	

///////////////////////////////////////////////////////////////////////////////////////////
// HOST FUNCTIONS
///////////////////////////////////////////////////////////////////////////////////////////

function delete_nagioscore_host($hostname,$reconfigure=true){
		
	$hid=nagiosql_get_host_id($hostname);
	
	// delete wizard meta associated with the host
	delete_host_configwizard_meta($hostname);

	// submit delete command
	if($hid>0)
		submit_command(COMMAND_NAGIOSQL_DELETEHOST,$hid);

	if($reconfigure==true)
		reconfigure_nagioscore();
	}


///////////////////////////////////////////////////////////////////////////////////////////
// SERVICE FUNCTIONS
///////////////////////////////////////////////////////////////////////////////////////////

function delete_nagioscore_service($hostname,$servicename,$reconfigure=true){
		
	$sid=nagiosql_get_service_id($hostname,$servicename);
	
	//  delete wizard meta associated with the service
	delete_service_configwizard_meta($hostname,$servicename);
	
	// submit delete command
	if($sid>0)
		submit_command(COMMAND_NAGIOSQL_DELETESERVICE,$sid);

	if($reconfigure==true)
		reconfigure_nagioscore();
	}

	
///////////////////////////////////////////////////////////////////////////////////////////
// MISC FUNCTIONS
///////////////////////////////////////////////////////////////////////////////////////////

// update nagios cgi config file
function update_nagioscore_cgi_config(){
	global $cfg;
	global $db_tables;
	
	$cfgfile=$cfg['component_info']["nagioscore"]["cgi_config_file"];
	$tmpfile=$cfgfile.".tmp";

	echo "CONFIGFILE: $cfgfile\n";
	echo "TMPFILE: $tmpfile\n";

	$tfh=fopen($tmpfile,"w");
	if(!$tfh){
		echo "Error creating temporary CGI config file!\n";
		return;
		}
	
	$fh=fopen($cfgfile,"r");
	if(!$fh){
		fclose($tfh);
		echo "Error opening the CGI config file!\n";
		return;
		}
		
	// construct permission strings
	$admins="";
	$allobjectusers="";
	$allobjectcommandusers="";
	$monitoringsystemusers="";
	
	$sql="SELECT username FROM ".$db_tables[DB_NAGIOSXI]["usermeta"]." LEFT JOIN ".$db_tables[DB_NAGIOSXI]["users"]." ON ".$db_tables[DB_NAGIOSXI]["usermeta"].".user_id=".$db_tables[DB_NAGIOSXI]["users"].".user_id WHERE ".$db_tables[DB_NAGIOSXI]["usermeta"].".keyname='authorized_for_all_objects' AND ".$db_tables[DB_NAGIOSXI]["usermeta"].".keyvalue='1'";
	if(($rs=exec_sql_query(DB_NAGIOSXI,$sql))){
		while(!$rs->EOF){
			$allobjectusers.=",".$rs->fields["username"];
			$rs->MoveNext();
			}
		}

	$sql="SELECT username FROM ".$db_tables[DB_NAGIOSXI]["usermeta"]." LEFT JOIN ".$db_tables[DB_NAGIOSXI]["users"]." ON ".$db_tables[DB_NAGIOSXI]["usermeta"].".user_id=".$db_tables[DB_NAGIOSXI]["users"].".user_id WHERE ".$db_tables[DB_NAGIOSXI]["usermeta"].".keyname='authorized_for_all_object_commands' AND ".$db_tables[DB_NAGIOSXI]["usermeta"].".keyvalue='1'";
	if(($rs=exec_sql_query(DB_NAGIOSXI,$sql))){
		while(!$rs->EOF){
			$allobjectcommandusers.=",".$rs->fields["username"];
			$rs->MoveNext();
			}
		}

	$sql="SELECT username FROM ".$db_tables[DB_NAGIOSXI]["usermeta"]." LEFT JOIN ".$db_tables[DB_NAGIOSXI]["users"]." ON ".$db_tables[DB_NAGIOSXI]["usermeta"].".user_id=".$db_tables[DB_NAGIOSXI]["users"].".user_id WHERE ".$db_tables[DB_NAGIOSXI]["usermeta"].".keyname='authorized_for_monitoring_system' AND ".$db_tables[DB_NAGIOSXI]["usermeta"].".keyvalue='1'";
	if(($rs=exec_sql_query(DB_NAGIOSXI,$sql))){
		while(!$rs->EOF){
			$monitoringsystemusers.=",".$rs->fields["username"];
			$rs->MoveNext();
			}
		}

	$sql="SELECT username FROM ".$db_tables[DB_NAGIOSXI]["usermeta"]." LEFT JOIN ".$db_tables[DB_NAGIOSXI]["users"]." ON ".$db_tables[DB_NAGIOSXI]["usermeta"].".user_id=".$db_tables[DB_NAGIOSXI]["users"].".user_id WHERE ".$db_tables[DB_NAGIOSXI]["usermeta"].".keyname='userlevel' AND ".$db_tables[DB_NAGIOSXI]["usermeta"].".keyvalue='255'";
	if(($rs=exec_sql_query(DB_NAGIOSXI,$sql))){
		while(!$rs->EOF){
			$admins.=",".$rs->fields["username"];
			$rs->MoveNext();
			}
		}

	//echo "SQL: $sql\n";
	//echo "ALLOBJUSERS: $allobjectusers\n";
	//echo "ALLOBJCMDUSERS: $allobjectcommandusers\n";
	//echo "MONSYSUSERS: $monitoringsystemusers\n";
	//echo "ADMINS: $admins\n";
	//exit();

	$afms="nagiosadmin".$admins.$monitoringsystemusers;
	$afci="nagiosadmin".$admins.$allobjectusers;
	$afaoc="nagiosadmin".$admins.$allobjectcommandusers;
	$afao="nagiosadmin".$admins.$allobjectusers;
	
		
	while($buf=fgets($fh)){
	
		$newbuf=$buf;
		
		$parts=explode("=",$buf);
		
		if($parts[0]=="authorized_for_all_host_commands")
			$newbuf=$parts[0]."=".$afaoc."\n";
		if($parts[0]=="authorized_for_all_service_commands")
			$newbuf=$parts[0]."=".$afaoc."\n";
		if($parts[0]=="authorized_for_all_hosts")
			$newbuf=$parts[0]."=".$afao."\n";
		if($parts[0]=="authorized_for_all_services")
			$newbuf=$parts[0]."=".$afao."\n";
			
		if($parts[0]=="authorized_for_configuration_information")
			$newbuf=$parts[0]."=".$afci."\n";

		if($parts[0]=="authorized_for_system_information")
			$newbuf=$parts[0]."=".$afms."\n";
		if($parts[0]=="authorized_for_system_commands")
			$newbuf=$parts[0]."=".$afms."\n";

		fputs($tfh,$newbuf);
		}

		
	fclose($tfh);
	fclose($fh);
	
	unlink($cfgfile);
	rename($tmpfile,$cfgfile);
		
	return;
	}

		
///////////////////////////////////////////////////////////////////////////////////////////
// MISC FUNCTIONS
///////////////////////////////////////////////////////////////////////////////////////////

function is_valid_timeperiod_timerange(&$start,&$end){
	if(is_valid_timeperiod_time($start)==false)
		return false;
	if(is_valid_timeperiod_time($end)==false)
		return false;
	$s=convert_timeperiod_time_to_num($start);
	$e=convert_timeperiod_time_to_num($end);
	if($s>$e)
		return false;
	return true;
	}
	
	
function is_valid_timeperiod_time(&$t){
	$parts=explode(":",$t);
	$n=count($parts);
	if($n<0 || $n>2){
		return false;
		}
	if($n==1)
		$parts[1]="0";
	$h=intval($parts[0]);
	$m=intval($parts[1]);
	if($h<0 || $h>24)
		return false;
	if($m<0 || $m>59)
		return false;
	//  looks okay, reformat time
	$t=sprintf("%02d:%02d",$h,$m);
	return true;
	}
	
function convert_timeperiod_time_to_num($t){
	$parts=explode(":",$t);
	$n=count($parts);
	if($n<0 || $n>2){
		return 0;
		}
	if($n==1)
		$parts[1]="0";
	$h=intval($parts[0]);
	$m=intval($parts[1]);
	if($h<0 || $h>24)
		return 0;
	if($m<0 || $m>59)
		return 0;
	$result=($h*60)+$m;
	return $result;
	}
	

		
///////////////////////////////////////////////////////////////////////////////////////////
// CONFIG SNAPSHOT FUNCTIONS
///////////////////////////////////////////////////////////////////////////////////////////

function get_nagioscore_config_snapshots(){
	global $cfg;
	
	$snapshots=array();
	
	// GET GOOD SNAPSHOTS
	// base checkpoints dir
	$dir=$cfg['nom_checkpoints_dir'];
	
	$p=$dir;
	$direntries=file_list($p,"/\.gz/");
	foreach($direntries as $de){
	
		$e=$de;
		
		$tarball=$e;
		$output=str_replace(".tar.gz",".txt",$e);
		$ts=intval(str_replace(".tar.gz","",$e));
		
		$snapshots[]=array(
			"file" => $tarball,
			"output" => $output,
			"timestamp" => $ts,
			"date" => get_datetime_string($ts),
			"error" => false,
			);
		}
	
	// GET ERROR SNAPSHOTS
	// base checkpoints dir
	$dir=$cfg['nom_checkpoints_dir']."errors/";
	
	$p=$dir;
	$direntries=file_list($p,"/\.gz/");
	foreach($direntries as $de){
	
		$e=$de;
		
		$tarball=$e;
		$output=str_replace(".tar.gz",".txt",$e);
		$ts=intval(str_replace(".tar.gz","",$e));
		
		$snapshots[]=array(
			"file" => $tarball,
			"output" => $output,
			"timestamp" => $ts,
			"date" => get_datetime_string($ts),
			"error" => true,
			);
		}
		
	// sort snapshots by time (desc)
	$dates=array();
	foreach ($snapshots as $key => $row) {
		$dates[$key] = $row['date'];
		}
	//print_r($dates);
	array_multisort($dates, SORT_DESC, $snapshots);
	
	return $snapshots;
	}
	

///////////////////////////////////////////////////////////////////////////////////////////
// PLUGIN FUNCTIONS
///////////////////////////////////////////////////////////////////////////////////////////

function get_nagioscore_plugins(){
	global $cfg;
	
	$plugins=array();
	
	$dir=$cfg['component_info']['nagioscore']['plugin_dir'];
	
	$p=$dir;
	$direntries=file_list($p,"");
	foreach($direntries as $de){

		$file=$de;
		$filepath=$dir."/".$file;
		$ts=filemtime($filepath);
		
		$perms=fileperms($filepath);
		$perm_string=file_perms_to_string($perms);
		
		$ownerarr=fileowner($filepath);
		if(function_exists('posix_getpwuid')){
			$ownerarr=posix_getpwuid($ownerarr);
			$owner=$ownerarr["name"];
			}
		else
			$owner=$ownerarr;
		$grouparr=filegroup($filepath);
		if(function_exists('posix_getgrgid')){
			$grouparr=posix_getgrgid($grouparr);
			$group=$grouparr["name"];
			}
		else
			$group=$grouparr;
		
		$plugins[]=array(
			"file" => $file,
			"timestamp" => $ts,
			"date" => get_datetime_string($ts),
			"perms" => $perms,
			"permstring" => $perm_string,
			"owner" => $owner,
			"group" => $group,
			);
		}
	
	return $plugins;
	}
	
		
?>