<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// Development Started 03/22/2008
// $Id: utils-notifications.inc.php 429 2011-01-03 20:41:26Z egalstad $

//require_once(dirname(__FILE__).'/common.inc.php');

////////////////////////////////////////////////////////////////////////
// NOTIFICATION FUNCTIONS
////////////////////////////////////////////////////////////////////////

function get_user_notification_message($userid,$ntype,$otype,$mtype){
	$msg="";
	$messages=array();
	$messages_raw=get_user_meta($userid,"notification_messages");
	if($messages_raw!=null){
		$messages=unserialize($messages_raw);
		if(array_key_exists($ntype,$messages)){
			if(array_key_exists($otype,$messages[$ntype])){
				if(array_key_exists($mtype,$messages[$ntype][$otype])){
					$msg=$messages[$ntype][$otype][$mtype];
					}
				}
			}
		}
	return $msg;
	}

// HOST EMAIL NOTIFICATIONS

function get_user_host_email_notification_subject($userid){
	$msg=get_user_notification_message($userid,"email","host","subject");
	if($msg=="")
		$msg="%type% Host Alert - %hostalias% is %hoststate%";
	return $msg;
	}
	
function get_user_host_email_notification_message($userid){
	$msg=get_user_notification_message($userid,"email","host","message");
	if($msg=="")
		$msg="***** Nagios XI Alert *****\n\nNotification Type: %type%\nHost: %host%\nState: %hoststate%\nAddress: %hostaddress%\nInfo: %hostoutput%\nDate/Time: %datetime%\n\nNagios URL: %xiserverurl%\n";
	return $msg;
	}

// SERVICE EMAIL NOTIFICATIONS
	
function get_user_service_email_notification_subject($userid){
	$msg=get_user_notification_message($userid,"email","service","subject");
	if($msg=="")
		$msg="%type% Service Alert - %hostalias%/%service% is %servicestate%";
	return $msg;
	}
	
function get_user_service_email_notification_message($userid){
	$msg=get_user_notification_message($userid,"email","service","message");
	if($msg=="")
		$msg="***** Nagios XI Alert *****\n\nNotification Type: %type%\n\nService: %service%\nHost: %hostalias%\nAddress: %hostaddress%\nState: %servicestate%\nInfo:\n%serviceoutput%\nDate/Time: %datetime%\n\nNagios URL: %xiserverurl%\n";
	return $msg;
	}
	
// HOST MOBILE TEXT NOTIFICATIONS

function get_user_host_mobiletext_notification_subject($userid){
	$msg=get_user_notification_message($userid,"mobiletext","host","subject");
	if($msg=="")
		$msg="%type% Host Alert";
	return $msg;
	}
	
function get_user_host_mobiletext_notification_message($userid){
	$msg=get_user_notification_message($userid,"mobiletext","host","message");
	if($msg=="")
		$msg="Host: %host%\nState: %hoststate%\nAddress: %hostaddress%\nInfo: %hostoutput%\nDate/Time: %datetime%\n\nNagios URL: %xiserverurl%\n";
	return $msg;
	}
	
// SERVICE MOBILE TEXT NOTIFICATIONS

function get_user_service_mobiletext_notification_subject($userid){
	$msg=get_user_notification_message($userid,"mobiletext","service","subject");
	if($msg=="")
		$msg="%type% Service Alert";
	return $msg;
	}
function get_user_service_mobiletext_notification_message($userid){
	$msg=get_user_notification_message($userid,"mobiletext","service","message");
	if($msg=="")
		$msg="Service: %service%\nHost: %hostalias%\nAddress: %hostaddress%\nState: %servicestate%\nInfo:\n%serviceoutput%\nDate/Time: %datetime%\n\nNagios URL: %xiserverurl%\n";
	return $msg;
	}

	
	
// used by notifications and event handlers....
function process_notification_text($msg,$args){
	$output=$msg;
	
	// add a few args...
	
	// nagios xi server url
	$args["xiserverurl"]=get_option('url');
	
	// server ip address (doesn't work from command line/cron)
	if(array_key_exists('SERVER_ADDR',$_SERVER))
		$args["xiserverip"]=$_SERVER['SERVER_ADDR'];
	else
		$args["xiserverip"]="0.0.0.0";
		
	// date/time string based on user preference
	$args["datetime"]=get_datetime_string(time());
	
	// other variables passed from nagios core notification script
	foreach($args as $var => $val){
		$tvar="%".$var."%";
		$output=str_replace($tvar,$val,$output);
		}
		
	// evaluate PHP code in the message
	// force the user to have a start tag so we recognize it, but strip it off before eval()
	if(substr($output,0,5)=="<?php")
		$output=eval(substr($output,5));
	
	return $output;
	}

	
// returns array of mobile provider ids and descriptions
function get_mobile_providers(){

	$mobile_providers=array();
	
	$mp=get_mobile_provider_info();
	foreach($mp as $mparr){
		$mobile_providers[$mparr["id"]]=$mparr["description"];
		}
		
	return $mobile_providers;
	}	
	
function get_mobile_provider_info(){

	// get info saved in database
	$mps=get_option("mobile_provider_info");
	if($mps!="")
		return unserialize($mps);

	// otherwise use defaults
	return get_default_mobile_provider_info();
	}

function get_default_mobile_provider_info(){

	$mobile_providers=array(
		array("id" => "alltel", "description" => "Alltel", "format" => "%number%@message.alltel.com"),
		array("id" => "att", "description" => "AT&T", "format" => "%number%@txt.att.net"),
		array("id" => "cingular", "description" => "Cingular", "format" => "%number%@cingularme.com"),
		array("id" => "metropcs", "description" => "Metro PCS", "format" => "%number%@mymetropcs.com"),
		array("id" => "nextel", "description" => "Nextel", "format" => "%number%@messaging.nextel.com"),
		array("id" => "powertel", "description" => "Powertel", "format" => "%number%@ptel.net"),
		array("id" => "sprint", "description" => "Sprint", "format" => "%number%@messaging.sprintpcs.com"),
		array("id" => "suncom", "description" => "SunCom", "format" => "%number%@tms.suncom.com"),
		array("id" => "tmobile", "description" => "T-Mobile", "format" => "%number%@tmomail.net"),
		array("id" => "uscellular", "description" => "US Cellular", "format" => "%number%@email.uscc.net"),
		array("id" => "verizon", "description" => "Verizon", "format" => "%number%@vtext.com"),
		array("id" => "virginmobile", "description" => "Virgin Mobile", "format" => "%number%@vmobl.com"),
		//"localhost" => "Localhost",
		);
		
	return $mobile_providers;
	}
	
	
function is_valid_mobile_number($num){

	// strip stuff out of the number
	$number=$num;
	$number=str_replace("-","",$number);
	$number=str_replace("+","",$number);
	$number=str_replace(" ","",$number);
	
	return true;
	}
	
function get_mobile_text_email($num,$provider){

	// strip stuff out of the number
	$number=$num;
	$number=str_replace("-","",$number);
	$number=str_replace("+","",$number);
	$number=str_replace(" ","",$number);

	$email="";
	
	// see if we can get the format from the array
	$format="";
	$mp=get_mobile_provider_info();
	foreach($mp as $mparr){
		if($mparr["id"]==$provider){
			$format=$mparr["format"];
			break;
			}
		}
	if($format!=""){
		$email=str_replace("%number%",$number,$format);
		}
	
	// else try default formats (original old code)...
	if($email!=""){
		switch($provider){
			case "alltel":
				$email=$number."@message.alltel.com";
				break;
			case "att":
				$email=$number."@txt.att.net";
				break;
			case "cingular":
				$email=$number."@cingularme.com";
				break;
			case "metropcs":
				$email=$number."@mymetropcs.com";
				break;
			case "nextel":
				$email=$number."@messaging.nextel.com";
				break;
			case "powertel":
				$email=$number."@ptel.net";
				break;
			case "sprint":
				$email=$number."@messaging.sprintpcs.com";
				break;
			case "suncom":
				$email=$number."@tms.suncom.com";
				break;
			case "tmobile":
				$email=$number."@tmomail.net";
				break;
			case "uscellular":
				$email=$number."@email.uscc.net";
				break;
			case "verizon":
				$email=$number."@vtext.com";
				break;
			case "virginmobile":
				$email=$number."@vmobl.com";
				break;
			case "localhost":
				$email=$number."@localhost";
				break;			
			default:
				break;
			}
		}
		
	return $email;
	}
	
	
function get_notification_reason_string($reason,$object_type,$state){
	
	$text="";
	
	switch($reason){
		case NOTIFICATIONREASON_NORMAL:
			//text="Normal";
			if($object_type==OBJECTTYPE_HOST){
				if($state==0)
					$text="Host Recovery";
				else
					$text="Host Problem";
				}
			else{
				if($state==0)
					$text="Service Recovery";
				else
					$text="Service Problem";
				}
			break;
		case NOTIFICATIONREASON_ACKNOWLEDGEMENT:
			$text="Problem Acknowledged";
			break;
		case NOTIFICATIONREASON_FLAPPINGSTART:
			$text="Flapping Started";
			break;
		case NOTIFICATIONREASON_FLAPPINGSTOP:
			$text="Flapping Stopped";
			break;
		case NOTIFICATIONREASON_FLAPPINGDISABLED:
			$text="Flapping Disabled";
			break;
		case NOTIFICATIONREASON_DOWNTIMESTART:
			$text="Downtime Started";
			break;
		case NOTIFICATIONREASON_DOWNTIMEEND:
			$text="Downtime Ended";
			break;
		case NOTIFICATIONREASON_DOWNTIMECANCELLED:
			$text="Downtime Cancelled";
			break;
		case NOTIFICATIONREASON_Custom:
			$text="Custom";
			break;
		default:
			break;
		}
	
	return $text;
	}

?>