<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// Development Started 03/22/2008
// $Id: utils-views.inc.php 75 2010-04-01 19:40:08Z egalstad $

//require_once(dirname(__FILE__).'/common.inc.php');

////////////////////////////////////////////////////////////////////////
// VIEW FUNCTIONS
////////////////////////////////////////////////////////////////////////

function add_view($userid,$url,$title){

	if(!have_value($title))
		$title="(untitled)";

	// strip base url out of $url for portability when using ip/fqdns
	$base_url=get_base_url();
	$urlparts=parse_url($base_url);
	$new_base=$urlparts["path"];
	$url=str_replace($base_url,$new_base,$url);
	
	$views=array();

	// get current view
	$viewsraw=get_user_meta($userid,"views");
	//echo "VIEWSRAW: $viewsraw<BR>";

	if($viewsraw!=null)
		$views=unserialize($viewsraw);
		

	$views[]=array(
		"id" => random_string(6),
		"url" => $url,
		"title" => $title
		);
		
	$viewsraw=serialize($views);
	set_user_meta($userid,"views",$viewsraw,false);
	return true;
	}
	
function update_view($userid,$id,$url,$title){
	$views=array();
	$viewsraw=get_user_meta($userid,"views");
	if($viewsraw!=null)
		$views=unserialize($viewsraw);
	//print_r($views);
	
	$n=0;
	foreach($views as $v){
		if($v["id"]==$id){
			$views[$n]["url"]=$url;
			$views[$n]["title"]=$title;
			//echo "<BR>FOUND!<BR>";
			break;
			}
		$n++;
		}
	//print_r($views);

	$viewsraw=serialize($views);
	set_user_meta($userid,"views",$viewsraw,false);
	return true;
	}
	
function get_views($userid){
	$views=array();
	$viewsraw=get_user_meta($userid,"views");
	//echo "UID: $userid, VIEWSRAW: $viewsraw<BR>";
	if($viewsraw!=null)
		$views=unserialize($viewsraw);
	return $views;
	}
	
function delete_view_number($userid,$num){
	$views=array();
	$viewsraw=get_user_meta($userid,"views");
	if($viewsraw!=null)
		$views=unserialize($viewsraw);
	unset($views[$num]);
	$newviews=array();
	foreach($views as $v){
		$newviews[]=$v;
		}
	$viewsraw=serialize($newviews);
	set_user_meta($userid,"views",$viewsraw,false);
	return true;
	}
	
function delete_view_id($userid,$id){
	$views=array();
	$viewsraw=get_user_meta($userid,"views");
	if($viewsraw!=null)
		$views=unserialize($viewsraw);

	//print_r($views);
	//echo "<BR>id: $id<BR>";
	
	$i=0;
	foreach($views as $v){
		if($v["id"]==$id){
			unset($views[$i]);
			break;
			}
		$i++;
		}
		
	$newviews=array();
	foreach($views as $v){
		$newviews[]=$v;
		}

	//print_r($newviews);

	$viewsraw=serialize($newviews);
	set_user_meta($userid,"views",$viewsraw,false);
	return true;
	}

	
function get_views_menu_html($userid){
	// get all user views
	$views=get_views($userid);
	//print_r($views);
	$mi=array();
	foreach($views as $view){
		$mi[]=array(
			"type" => "link",
			"title" => $view["title"],
			"opts" => array(
				"href" => $view["url"],
				"class" => "myviewlink",
				"id" => "view-".$view["id"]
				)
			);
		}
	$html=get_menu_items_html($mi);
	return $html;
	}


	
?>