<?php
//
// Copyright (c) 2008-2011 Nagios Enterprises, LLC.  All rights reserved.
// 
// IMPORTANT: SOURCE CODE MAY NOT BE DISCLOSED OR DISTRIBUTED IN UNENCODED FORM
//            WITHOUT EXPLICIT PERMISSION FROM NAGIOS ENTERPRISES.
//  
// $Id: login.php 541 2011-02-05 12:52:22Z egalstad $

require_once(dirname(__FILE__).'/includes/common.inc.php');
/*
require_once(dirname(__FILE__).'/config.inc.php');
require_once(dirname(__FILE__).'/includes/auth.inc.php');
require_once(dirname(__FILE__).'/includes/utils.inc.php');
require_once(dirname(__FILE__).'/includes/pageparts.inc.php');
*/

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();


route_request();

function route_request(){
	global $request;
	
	$pageopt=get_pageopt("");
	
	switch($pageopt){
		case "logout":
			do_logout();
			break;
		case "changepass":
			do_changepass();
			break;
		case "forcepasswordchange":
			show_changepass();
			break;
		case "showlicense":
			show_license();
			break;
		case "agreelicense":
			do_agree_license();
			break;
		case "forgotpass":
			show_resetpass();
			break;
		case "resetpass":
			do_resetpass();
			break;
		case "login":
			do_login();
			break;
		case "resethomi":
			reset_homi();
			break;
		default:
			show_login();
			break;
		}

	}

function show_login($error=false,$msg=""){
	global $cfg;
	global $request;
	global $lstr;
	
	// if user is currently logged in, log them out
	if(is_authenticated()==true)
		do_logout();
		
		
	// get vars
	$redirect=grab_request_var("redirect","");
	$debug=grab_request_var("debug","");

	// page start
	do_page_start(array("page_title"=>$lstr['LoginPageTitle']));
?>
	<h1><?php echo $lstr['LoginPageHeader'];?></h1>
<?php
	if(isset($request['logout']))
		$infomsg=true;
	else
		$infomsg=false;
		
	// permalink to main url - special case! - manual redirect...
	$xiwindow=grab_request_var("xiwindow","");
	if(have_value($redirect)==false && have_value($xiwindow)==true){
		$redirect="index.php?xiwindow=".$xiwindow;
		}
		
	// see if user timed out
	$timeout=false;
	// we have a redirect - looks like user's session timed out
	if(have_value($redirect)==true && $error==false && $msg==""){
		if(strcmp("/nagiosxi/index.php",$redirect))
			$timeout=false;
		else
			$timeout=true;
		}
	// additional request variables were sent (other than login page) - looks like session timed out
	else{
		foreach($request as $var => $val){
			/*
			if($var=="page" && $val==PAGE_LOGIN)
				continue;
			if($var=="pageopt" && $val=="logout")
				continue;
			if($var=="pageopt" && $val=="login")
				continue;
			$timeout=true;
			*/
			break;
			}
		}
	if($timeout==true  && $error==false){
		$msg=$lstr['SessionTimedOut'];
		$infomsg=true;
		}
		
	display_message($error,$infomsg,$msg);
?>

	<form id="loginForm" method="post" action="<?php echo htmlentities($_SERVER['PHP_SELF']);?>">
	<?php echo get_nagios_session_protector();?>
	
	<fieldset>
	<legend><?php echo $lstr['LoginPageLegend'];?></legend>
	
	<input type="hidden" name="page" value="auth">
	<input type="hidden" name="debug" value="<?php echo htmlentities($debug);?>">
	<input type="hidden" name="pageopt" value="login">
<?php
	if(have_value($redirect)==true){
?>
	<input type="hidden" name="redirect" value="<?php echo encode_form_val($redirect);?>">
<?php
		}
?>
	<label for="usernameBox"><?php echo $lstr['UsernameBoxTitle'];?>:</label><br class="nobr" />
	<input type="text" size="10" name="username" id="usernameBox" class="textfield" /><br class="nobr" />
	
	<label for="passwordBox"><?php echo $lstr['Password1BoxTitle'];?>:</label><br class="nobr" />
	<input type="password" size="10" name="password" id="passwordBox" class="textfield" /><br class="nobr" />
	
	<div id="formButtons">
	<input type="submit" class="submitbutton" value="<?php echo $lstr['LoginButton'];?>" id="loginButton"><br class="nobr" />
	</div>
	
	</fieldset>
	</form>
	
	<script type="text/javascript" language="JavaScript">
	document.forms['loginForm'].elements['usernameBox'].focus();
	</script>
	
	<br class="nobr" />

	<p>
	<a href="?forgotpass"><?php echo $lstr['ForgotPasswordText'];?></a>
	</p>
	
<?php
	// page end
	do_page_end();
	
	exit();
	}
	
	
function check_login_credentials($username,$password,&$info_msg,&$debug_msg){
	global $db_tables;
	global $DB;
	global $callbacks;
	
	// clear messages
	$info_msg=array();
	$debug_msg=array();
	
	// default Nagios XI authentication - check MD5 hash of password against database
	$sql="SELECT * FROM ".$db_tables[DB_NAGIOSXI]["users"]." WHERE username='".escape_sql_param($username,DB_NAGIOSXI)."' AND password='".md5(escape_sql_param($password,DB_NAGIOSXI))."'";
	if(($rs=$DB[DB_NAGIOSXI]->Execute($sql))){
		if($arr=$rs->FetchRow()){ 
			$debug_msg[]="Username/password match Nagios XI database information.";
			return true;
			}
		else{
			$debug_msg[]="Username/password do not match data stored in Nagios XI database.";
			}
		}
	else{
		$debug_msg[]="Error running SQL query against Nagios XI database.";
		}
		
	// try other authentication methods...
	$auth_ok=false;
	$cbargs=array(
		"credentials" => array(
			"username" => $username,
			"password" => $password,
			),
		"login_ok" => 0,
		"info_messages" => array(),
		"debug_messages" => array(),
		);
	if(array_key_exists(CALLBACK_PROCESS_AUTH_INFO,$callbacks)){
		foreach($callbacks[CALLBACK_PROCESS_AUTH_INFO] as $cb){
		
			// try this authentication method
			$cb(CALLBACK_PROCESS_AUTH_INFO,$cbargs);
			
			/*
			echo "CBARGS:<BR>";
			print_r($cbargs);
			echo "<BR>";
			*/
			
			// login was okay, so stop processing...
			if($cbargs["login_ok"]==1){
				$auth_ok=true;
				break;
				}			
			}
		}
		
	$info_msg=array_merge($info_msg,$cbargs["info_messages"]);
	$debug_msg=array_merge($debug_msg,$cbargs["debug_messages"]);
		
	// a component authenticated the user
	if($auth_ok==true)
		return true;

	return false;
	}

	
function do_login(){
	global $request;
	global $cfg;
	global $db_tables;
	global $DB;
	global $lstr;

	
	// check session
	check_nagios_session_protector();
	
	// grab username and password
	$username=grab_request_var("username");
	$password=grab_request_var("password");
	
	// grab other info
	$debug=grab_request_var("debug");

	// defaults
	$login_error=true;	
	$login_errmsg=$lstr['InvalidUsernamePasswordError'];
			
	// credentials checked out okay!
	if(check_login_credentials($username,$password,$info_msg,$debug_msg)==true)
		$login_error=false;
	
	// do some more processing
	if($login_error==false){
	
		// look the user information up in Nagios XI database
		$sql="SELECT * FROM ".$db_tables[DB_NAGIOSXI]["users"]." WHERE username='".escape_sql_param($username,DB_NAGIOSXI)."'";
		if(($rs=$DB[DB_NAGIOSXI]->Execute($sql))){
		
			// account was found in the Nagios XI database
			if($arr=$rs->FetchRow()){ 
			
				// account is disabled
				if($arr["enabled"]!=1){
					$login_error=true;
					$login_errmsg="The specified user account has been disabled or does not exist.";
					}
					
				// else login checks out okay
				else{

					$login_error=false;
						
					// set session variables
					$_SESSION["user_id"]=$arr["user_id"];
					$_SESSION["username"]=$arr["username"];
					
					// see if the user needs to agree to the license
					if(user_has_agreed_to_license()==false)
						$_SESSION["agreelicense"]=1;
					
					// load user session variables (e.g. preferences)
					get_user_meta_session_vars(true);
					
					// save last login time
					set_user_meta(0,"lastlogintime",time());
					
					// increment times logged in
					$times=get_user_meta(0,"timesloggedin");
					if($times==null)
						$times=0;
					$times++;
					set_user_meta(0,"timesloggedin",$times);
									
					// add a home dashboard if they don't have one
					$homedash=get_dashboard_by_id(0,HOMEPAGE_DASHBOARD_ID);
					if($homedash==null){
						// add the dashboard
						add_dashboard(0,HOMEPAGE_DASHBOARD_TITLE,null,HOMEPAGE_DASHBOARD_ID,true);
						
						// add some dashlets...
						}

					// add a screen dashboard if they don't have one
					delete_dashboard_id(0,SCREEN_DASHBOARD_ID);
					$screendash=get_dashboard_by_id(0,SCREEN_DASHBOARD_ID);
					if($screendash==null){
						// add the dashboard
						add_dashboard(0,SCREEN_DASHBOARD_TITLE,null,SCREEN_DASHBOARD_ID,true);
						}

					// sync username/password with Nagios Core (basic authentication)
					$args=array(
						"username" => $request["username"],
						"password" => $request["password"]
						);
					submit_command(COMMAND_NAGIOSXI_SET_HTACCESS,serialize($args));		

					// they haven't seen the login alerts screen yet
					$_SESSION["has_seen_login_alerts"]=false;
					}
				}
				
				// row could not be found - user doesn't exist in Nagios XI
				else{
					$login_error=true;
					$login_errmsg="The specified user account has not been setup in this application - contact your Nagios XI administrator.";
					}
			}
			
			// error encountered running the SQL query
			else{
				$login_error=true;
				$login_errmsg="An error was encountered when looking up the user in the Nagios XI database.";
				}
		}

	// an error occurred - redirect to login page
	if($login_error==true){
		$login_msg=array();
		$login_msg[]=$login_errmsg;
		if($debug==1){
			$login_msg[]="";
			$login_msg[]="<b>Debug Information:</b>";
			$error_msgs=array_merge($login_msg,$debug_msg);
			}
		else
			$error_msgs=$login_msg;
		show_login(true,$error_msgs);
		}
		
	// login was okay, but user wants debug information
	else if($debug==1){
		echo "AUTH INFO:<BR>";
		print_r($info_msg);
		echo "<BR>DEBUG INFO:<BR>";
		print_r($debug_msg);
		exit();
		}

	//  login was okay
	else{

		// check for updates
		do_update_check();
		
		// check if upgrade is needed
		if(upgrade_needed()==true && is_admin()==true){
			header("Location: ".get_base_url().PAGEFILE_UPGRADE);
			exit();
			}

		// redirect user
		$redirecturl=grab_request_var("redirect","");
		if(have_value($redirecturl))
			$url=$redirecturl;
		else{
			$url="index.php";
			//$url.="";
			}
		header("Location: ".$url);
		}
	}
	

function do_logout(){
	global $lstr;

	// HTTP BASIC AUTHENTICATION support
	if(is_http_basic_authenticated()){
		echo "Error: You cannot logout when using HTTP Basic Authentication.";
		exit();
		//show_login(true,"You cannot logout when using HTTP Basic Authentication.");
		//exit();
		}

	//  destroy the session.
	deinit_session();
	
	init_session();
	
	show_login(false,$lstr['LoggedOutText']);
	}
	
	


function show_resetpass($error=false,$msg=""){
	global $request;
	global $lstr;
	
	// display page
	do_page_start($lstr['ResetPasswordPageTitle']);
?>
	<h1><?php echo $lstr['ResetPasswordPageHeader'];?></h1>
<?php	
	display_message($error,false,$msg);
?>

	<p>
	<?php echo $lstr['ResetPasswordNote'];?>
	</p>
	
	<form id="resetForm" method="post" action="">
	<fieldset>
	<input type="hidden" name="page" value="<?php echo htmlentities($_SERVER['PHP_SELF']);?>">
	<input type="hidden" name="pageopt" value="resetpass">
	<?php echo get_nagios_session_protector();?>
	
<?php
	if(isset($request["redirect"])){
?>
	<input type="hidden" name="redirect" value="<?php echo encode_form_val($request["redirect"]);?>">
<?php
		}
?>
	<label for="usernameBox"><?php echo $lstr['UsernameBoxTitle'];?>:</label><br class="nobr" />
	<input type="text" size="10" name="username" id="usernameBox" class="textfield" /><br class="nobr" />
	
	<div id="formButtons">
	<input type="submit" class="submitbutton" value="<?php echo $lstr['ResetPasswordButton'];?>" id="resetButton"><br class="nobr" />
	</div>
	
	</fieldset>
	</form>
	
	<script type="text/javascript" language="JavaScript">
	document.forms['resetForm'].elements['usernameBox'].focus();
	</script>
<?php

	do_page_end();
	exit();
	}
	
	
function do_resetpass(){
	global $request;
	global $cfg;
	global $db_tables;
	global $lstr;

	$errors=0;
	$errmsg=array();


	
	// check session
	check_nagios_session_protector();

	if(in_demo_mode()==true)
		$errmsg[$errors++]=$lstr['DemoModeChangeError'];
		
	// grab variables
	$username=grab_request_var("username","");

	// check for errors
	if(have_value($username)==false)
		$errmsg[$errors++]=$lstr['NoUsernameError'];
	else if(!($user_id=get_user_id($request["username"])))
		$errmsg[$errors++]=$lstr['NoMatchingAccountError'];
	
	// lookup email addresses	
	if(!have_value($user_email=get_user_attr($user_id,'email')))
		$errmsg[$errors++]=$lstr['UnableAccountEmailError'];
		
	
	// an error occurred
	if($errors>0)
		show_resetpass(true,$errmsg);

	// generate a new password		
	$new_password=random_string(6);
	change_user_attr($user_id,'password',md5($new_password));

	// force user to change password at next login
	set_user_meta($user_id,'forcepasswordchange','1');

	$url=get_option('url');
	$adminname=get_option("admin_name");
	$adminemail=get_option("admin_email");
	
	// send email
	$message=sprintf($lstr['PasswordResetEmailMessage'],$new_password,$url);
	$opts=array(
		"from" => $adminname." <".$adminemail.">\r\n",
		"to" => $user_email,
		"subject" => $lstr['PasswordResetEmailSubject'],
		"message" => $message,
		);
	send_email($opts);

	// success!		
	do_page_start($lstr['PasswordSentPageTitle']);
?>	
	<h1><?php echo $lstr['PasswordSentPageHeader'];?></h1>
	<p>
	<?php echo $lstr['PasswordSentNote'];?>
	</p>
	<p>
	<a href="<?php echo get_base_url().PAGEFILE_LOGIN;?>"><?php echo $lstr['LoginText'];?></a>
	</p>
<?php
	do_page_end();
	exit();
	}
	

function show_changepass($error=false,$msg=""){
	global $request;
	global $lstr;
	
	// display page
	do_page_start($lstr['ForcePasswordChangePageTitle']);
?>
	<h1><?php echo $lstr['ForcedPasswordChangePageHeader'];?></h1>
<?php	
	display_message($error,false,$msg);
?>

	<p>
	<?php echo $lstr['ForceChangePasswordNote'];?>
	</p>
	
	<form id="changeForm" method="post" action="">
	<fieldset>
	<input type="hidden" name="page" value="<?php echo htmlentities($_SERVER['PHP_SELF']);?>">
	<input type="hidden" name="pageopt" value="changepass">
	<?php echo get_nagios_session_protector();?>
	
	<label for="passwordBox1"><?php echo $lstr['NewPassword1BoxTitle'];?>:</label><br class="nobr" />
	<input type="password" size="10" name="password1" id="passwordBox1" class="textfield" /><br class="nobr" />
	
	<label for="passwordBox2"><?php echo $lstr['NewPassword2BoxTitle'];?>:</label><br class="nobr" />
	<input type="password" size="10" name="password2" id="passwordBox2" class="textfield" /><br class="nobr" />

	<div id="formButtons">
	<input type="submit" class="submitbutton" value="<?php echo $lstr['ChangePasswordButton'];?>" id="changeButton"><br class="nobr" />
	</div>

	</fieldset>
	</form>
	
	<script type="text/javascript" language="JavaScript">
	document.forms['changeForm'].elements['passwordBox1'].focus();
	</script>
<?php

	do_page_end();
	exit();
	}

	
function do_changepass(){
	global $request;
	global $lstr;

	$errors=0;
	$errmsg=array();
	
	
	// check session
	check_nagios_session_protector();

	$password1=grab_request_var("password1","");
	$password2=grab_request_var("password2","");

	if(have_value($password1)==false)
		$errmsg[$errors++]=$lstr['BlankPasswordError'];
	else if(have_value($password2)==false || strcmp($password1,$password2))
		$errmsg[$errors++]=$lstr['MismatchedPasswordError'];
	
	// an error occurred
	if($errors>0)
		show_changepass(true,$errmsg);

	// save new password
	change_user_attr($_SESSION["user_id"],'password',md5($password1));

	// clear force password change option
	delete_user_meta($_SESSION["user_id"],'forcepasswordchange');
	unset($_SESSION["forcepasswordchange"]);

	// redirect user
	header("Location: index.php");
	}



function show_license($error=false,$msg=""){
	global $request;
	global $lstr;
	
	// display page
	do_page_start(array("page_title"=>$lstr['AgreeLicensePageTitle']));
?>
	<h1><?php echo $lstr['AgreeLicensePageHeader'];?></h1>
<?php	
	display_message($error,false,$msg);
?>

	<p>
	<?php echo $lstr['AgreeLicenseNote'];?>
	</p>
	
	<form id="changeForm" method="post" action="">
	<fieldset>
	<input type="hidden" name="page" value="<?php echo htmlentities($_SERVER['PHP_SELF']);?>">
	<input type="hidden" name="pageopt" value="agreelicense">
	<?php echo get_nagios_session_protector();?>
	
	<table>
	
	<tr>
	<td colspan="2">
<textarea rows="15" cols="90" readonly>
<?php 
echo get_raw_license_text();
?>
</textarea>
	</td>
	</tr>
	
	<tr><td><br></td></tr>
	
	<tr>
	<td>
	<input type="checkbox" class="checkbox" id="agree_license" name="agree_license"><br class="nobr" />
	</td>
	<td>
	<label><?php echo $lstr['AgreeToLicenseBoxText'];?></label>
	</td>
	</tr>
	
	</table>

	<div id="formButtons">
	<input type="submit" class="submitbutton" value="<?php echo $lstr['SubmitButton'];?>" id="submitButton"><br class="nobr" />
	</div>

	</fieldset>
	</form>
	
<?php

	do_page_end();
	exit();
	}

	
function do_agree_license(){
	global $request;
	global $lstr;

	$errors=0;
	$errmsg=array();
	
	
	// check session
	check_nagios_session_protector();

	$agree_license=checkbox_binary(grab_request_var("agree_license",""));

	if($agree_license!=1)
		$errmsg[$errors++]=$lstr['AgreeLicenseError'];
		
	// an error occurred
	if($errors>0)
		show_license(true,$errmsg);

	set_user_has_agreed_to_license(0);

	//echo "AGREE: $agree_license";
	//exit();
	
	// clear agree license option
	unset($_SESSION["agreelicense"]);

	// redirect user
	header("Location: index.php");
	}

?>


