<?php
// HEATMAP
//
// Copyright (c) 2010 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: histogram.php 334 2010-10-10 22:19:45Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);


route_request();

function route_request(){
	global $request;


	get_heatmap_data();

	$mode=grab_request_var("mode","");
	switch($mode){
		case "image":
			generate_heatmap_image();
			break;
		case "pdf":
			generate_heatmap_pdf();
			break;
		default:
			display_heatmap();
			break;
		}
	}


	
///////////////////////////////////////////////////////////////////
// REPORT GENERATION FUCNTIONS
///////////////////////////////////////////////////////////////////

function display_heatmap(){
	global $lstr;
	global $request;
	global $heatmap_points;

	// makes sure user has appropriate license level
	licensed_feature_check();

	
	// get values passed in GET/POST request
	$reportperiod=grab_request_var("reportperiod","last24hours");
	$startdate=grab_request_var("startdate","");
	$enddate=grab_request_var("enddate","");
	$search=grab_request_var("search","");
	$host=grab_request_var("host","");
	$service=grab_request_var("service","");
	$hostgroup=grab_request_var("hostgroup","");
	$servicegroup=grab_request_var("servicegroup","");
	$records=25;

	$width=grab_request_var("width",500);
	$height=grab_request_var("height",400);
	$radius=grab_request_var("radius",12);
	$usemap=grab_request_var("usemap",1);
	$useeffects=grab_request_var("useeffects",0);
	$statetype=grab_request_var("statetype","hard");

	// fix search
	if($search==$lstr['SearchBoxText'])
		$search="";
	

	// start/end times must be in unix timestamp format
	// if they weren't specified, default to last 24 hours
	//$endtime=grab_request_var("endtime",time());
	//$starttime=grab_request_var("starttime",$endtime-(24*60*60));
	
	// determine start/end times based on period
	get_times_from_report_timeperiod($reportperiod,$starttime,$endtime,$startdate,$enddate);
	

	// start the HTML page
	do_page_start(array("page_title"=>"Alert Heatmap"),true);
	
?>
	<h1>Alert Heatmap</h1>

<?php
	if($service!=""){
?>
	<div class="servicestatusdetailheader">
	<div class="serviceimage">
	<!--image-->
	<?php show_object_icon($host,$service,true);?>
	</div>
	<div class="servicetitle">
	<div class="servicename"><a href="<?php echo get_service_status_detail_link($host,$service);?>"><?php echo htmlentities($service);?></a></div>
	<div class="hostname"><a href="<?php echo get_host_status_detail_link($host);?>"><?php echo htmlentities($host);?></a></div>
	</div>
	</div>
	<br clear="all">

<?php
		}
	else if($host!=""){
?>
	<div class="hoststatusdetailheader">
	<div class="hostimage">
	<!--image-->
	<?php show_object_icon($host,"",true);?>
	</div>
	<div class="hosttitle">
	<div class="hostname"><a href="<?php echo get_host_status_detail_link($host);?>"><?php echo htmlentities($host);?></a></div>
	</div>
	</div>
	<br clear="all">
<?php
		}
?>
	
<?php
	
?>
	<form method="get" action="<?php echo htmlentities($_SERVER["REQUEST_URI"]);?>">
	<input type="hidden" name="host" value="<?php echo htmlentities($host);?>">
	<input type="hidden" name="service" value="<?php echo htmlentities($service);?>">
	
	<div class="reportexportlinks">
	<?php echo get_add_myreport_html("Alert Heatmap",$_SERVER["REQUEST_URI"],array());?>
<?php
	$url="?1";
	foreach($request as $var => $val)
		$url.="&".urlencode($var)."=".urlencode($val);
?>
	<a href="<?php echo $url;?>&mode=pdf&rand=<?php echo time();?>" alt="Download As PDF" title="Download As PDF"><img src="<?php echo theme_image("pdf.png");?>"></a>
	</div>
	
	<div class="reportsearchbox">
<?php
	// search box
	$searchclass="textfield";
	if(have_value($search)==true){
		$searchstring=$search;
		$searchclass.=" newdata";
		}
	else
		$searchstring=$lstr['SearchBoxText'];
?>
	<input type="text" size="15" name="search" id="searchBox" value="<?php echo encode_form_val($searchstring);?>" class="<?php echo $searchclass;?>" />
	</div>
	
<?php
	$auto_start_date=date('m/d/Y',strtotime('yesterday'));
	$auto_end_date=date('m/d/Y');
?>
	
	<script type="text/javascript">
	$(document).ready(function(){
		$('#startdateBox').click(function(){
			$('#reportperiodDropdown').val('custom');
			if($('#startdateBox').val()=='' && $('#enddateBox').val()==''){
				$('#startdateBox').val('<?php echo $auto_start_date;?>');
				$('#enddateBox').val('<?php echo $auto_end_date;?>');
				}
			});
		$('#enddateBox').click(function(){
			$('#reportperiodDropdown').val('custom');
			if($('#startdateBox').val()=='' && $('#enddateBox').val()==''){
				$('#startdateBox').val('<?php echo $auto_start_date;?>');
				$('#enddateBox').val('<?php echo $auto_end_date;?>');
				}
			});
		
		});
	</script>

	<div class="reporttimepicker">
	Period&nbsp;
	<select id='reportperiodDropdown' name="reportperiod">
<?php
	$tp=get_report_timeperiod_options();
	foreach($tp as $shortname => $longname){
		echo "<option value='".$shortname."' ".is_selected($shortname,$reportperiod).">".$longname."</option>";
		}
?>
	</select>
	&nbsp;From&nbsp;
	<input class="textfield" type="text" id='startdateBox' name="startdate" value="<?php echo encode_form_val(get_datetime_from_timestring($startdate)); ?>" size="16" />
	<div class="reportstartdatepicker"><img src="<?php echo theme_image("calendar_small.png");?>"></div>
	&nbsp;To&nbsp;
	<input class="textfield" type="text" id='enddateBox' name="enddate" value="<?php echo encode_form_val(get_datetime_from_timestring($enddate)); ?>" size="16" />
	<div class="reportenddatepicker"><img src="<?php echo theme_image("calendar_small.png");?>"></div>
	&nbsp;
	<input type='submit' class='reporttimesubmitbutton' name='reporttimesubmitbutton' value='Go'>
	</div>
	
	<div class="reportoptionpicker">

	Limit To&nbsp;
	<select name="hostgroup" id="hostgroupList">
	<option value="">Hostgroup:</option>
<?php
	$oxml=get_xml_hostgroup_objects();
	if($oxml){
		foreach($oxml->hostgroup as $hg){
			$name=strval($hg->hostgroup_name);
			echo "<option value='".$name."' ".is_selected($hostgroup,$name).">$name</option>\n";
			}
		}
?>
	</select>
	<select name="servicegroup" id="servicegroupList">
	<option value="">Servicegroup:</option>
<?php
	$oxml=get_xml_servicegroup_objects();
	if($oxml){
		foreach($oxml->servicegroup as $sg){
			$name=strval($sg->servicegroup_name);
			echo "<option value='".$name."' ".is_selected($servicegroup,$name).">$name</option>\n";
			}
		}
?>
	</select>

	<script type="text/javascript">
	$(document).ready(function(){
		$('#servicegroupList').change(function() {
			$('#hostgroupList').val('');
			});
		$('#hostgroupList').change(function() {
			$('#servicegroupList').val('');
			});
		});
	</script>


	Map Links&nbsp;
	<select id='usemapDropdown' name="usemap">
	<option value='1' <?php echo is_selected(1,$usemap);?>>Yes</option>
	<option value='0' <?php echo is_selected(0,$usemap);?>>No</option>
	</select>
	&nbsp;Effects&nbsp;
	<select id='useeffectsDropdown' name="useeffects">
	<option value='1' <?php echo is_selected(1,$useeffects);?>>Yes</option>
	<option value='0' <?php echo is_selected(0,$useeffects);?>>No</option>
	</select>
	&nbsp;State Types&nbsp;
	<select id='statetypeDropdown' name="statetype">
	<option value='soft' <?php echo is_selected("soft",$statetype);?>>Soft</option>
	<option value='hard' <?php echo is_selected("hard",$statetype);?>>Hard</option>
	<option value='both' <?php echo is_selected("both",$statetype);?>>Both</option>
	</select>
	Size
	<input class="textfield" type="text" id='widthBox' name="width" value="<?php echo encode_form_val($width); ?>" size="3" />
	&nbsp;x&nbsp;
	<input class="textfield" type="text" id='heightBox' name="height" value="<?php echo encode_form_val($height); ?>" size="3" />
	</div>
		
	
	
	<div>
	From: <b><?php echo get_datetime_string($starttime,DT_SHORT_DATE_TIME,DF_AUTO,"null");?></b> To: <b><?php echo get_datetime_string($endtime,DT_SHORT_DATE_TIME,DF_AUTO,"null");?></b>
	</div>

<?php
	$total_records=count($heatmap_points);

	// determine paging information
	$args=array(
		"reportperiod" => $reportperiod,
		"startdate" => $startdate,
		"enddate" => $enddate,
		"starttime" => $starttime,
		"endtime" => $endtime,
		"search" => $search,
		"host" => $host,
		"service" => $service,
		"width" => $width,
		"height" => $height,
		"radius" => $radius,
		"usemap" => $usemap,
		);
	$pager_results=get_table_pager_info("",$total_records,1,-1,$args);
	$first_record=(($pager_results["current_page"]-1)*$records);
?>
	<div class="recordcounttext">
	<?php
	$clear_args=array(
		"reportperiod" => $reportperiod,
		"startdate" => $startdate,
		"enddate" => $enddate,
		"starttime" => $starttime,
		"endtime" => $endtime,
		"host" => $host,
		"service" => $service,
		//"search" => $search,
		"width" => $width,
		"height" => $height,
		"radius" => $radius,
		"usemap" => $usemap,		
		);
	echo table_record_count_text($pager_results,$search,true,$clear_args);
	?>
	</div>	
	
<?php		
	if($total_records==0){
		echo "<p>No matching events to map.  Try expanding your search criteria.</p>";
		}
	/*
	else
		echo "<p>$total_records event(s) mapped.</p>";
	*/

	get_heatmap_html();
	
	
	
	// closes the HTML page
	do_page_end(true);
	}
	
function get_heatmap_html(){
	global $request;
	global $heatmap_points;
	
	$width=grab_request_var("width",500);
	$height=grab_request_var("height",400);
	$radius=grab_request_var("radius",12);
	$usemap=grab_request_var("usemap",1);
	$useeffects=grab_request_var("useeffects",0);


	$url=urlencode(get_current_page())."?".time();
	foreach($request as $var => $val)
		$url.="&".urlencode($var)."=".urlencode($val);
?>
	<table border="0">
	<tr>
	<td>A<br>L<br>E<br>R<br>T<br>S</td>
	<td colspan="3" align="center" valign="center" width="<?php echo $width;?>px" height="<?php echo $height;?>px">
	<div style="z-index: -1; position: absolute;  width: <?php echo $width;?>px; height: <?php echo $height;?>px;"><img src="<?php echo theme_image("throbber.gif");?>"><br>Generating heatmap image...</div>
	<img src="<?php echo $url;?>&mode=image" class="map" usemap="#theheatmap" width="<?php echo $width;?>px" height="<?php echo $height;?>px" style="border: 1px solid black; display: inline; z-index:1;">
	</td>
	</tr>
	<tr>
	<td></td><td align="left" width="30%">Earlier</td><td align="center" width="35%">Time</td><td align="right" width="30%">More Recent</td>
	</tr>
	</table>
	
<?php
	if($usemap==1)
		get_heatmap_imagemap();
?>

	<script type="text/javascript" src="../includes/js/jquery/jquery.maphilight.min.js"></script>
 <script type="text/javascript" src="../includes/js/jquery/jquery.metadata.min.js"></script>

 <?php
	if($useeffects==1){
?>
    <script>
	$(document).ready(function(){
        $('.map').maphilight();
		})
	</script>
<?php
		}
?>
<?php
	}
	
function generate_heatmap_pdf(){
	global $lstr;
	global $request;
	global $heatmap_points;

	//require_once(dirname(__FILE__).'/../includes/fpdf/fpdf.php');
	require_once(dirname(__FILE__).'/../includes/fpdf/fpdf_alpha.php');
	require_once(dirname(__FILE__).'/../includes/fpdf/nagiospdf.php');
	
	// get values passed in GET/POST request
	$reportperiod=grab_request_var("reportperiod","last24hours");
	$startdate=grab_request_var("startdate","");
	$enddate=grab_request_var("enddate","");
	$search=grab_request_var("search","");
	$host=grab_request_var("host","");
	$service=grab_request_var("service","");
	$hostgroup=grab_request_var("hostgroup","");
	$servicegroup=grab_request_var("servicegroup","");
	
	$width=grab_request_var("width",500);
	$height=grab_request_var("height",400);
	$radius=grab_request_var("radius",12);
	
	// adjust width/height
	/*
	if($width>190)
		$width=190;
	if($height>100)
		$height=100;
	*/
	
	// fix search
	if($search==$lstr['SearchBoxText'])
		$search="";

	// determine start/end times based on period
	get_times_from_report_timeperiod($reportperiod,$starttime,$endtime,$startdate,$enddate);


	$date_text="".get_datetime_string($starttime,DT_SHORT_DATE_TIME,DF_AUTO,"null")." To ".get_datetime_string($endtime,DT_SHORT_DATE_TIME,DF_AUTO,"null")."";
	
	$pdf=new NagiosReportPDF();
	$pdf->page_title='Alert Heatmap';
	$pdf->page_subtitle="";
	if($service!=""){
		$pdf->page_subtitle.=$host."\n";
		$pdf->page_subtitle.=$service."\n\n";
		}
	else if($host!=""){
		$pdf->page_subtitle.=$host."\n\n";
		}
	else if($hostgroup!=""){
		$pdf->page_subtitle.=$hostgroup."\n\n";
		}
	else if($servicegroup!=""){
		$pdf->page_subtitle.=$servicegroup."\n\n";
		}
	$pdf->page_subtitle.=$date_text."";
	if($search!="")
		$pdf->page_subtitle.=" Matching '".$search."'";
	
	$pdf->AliasNbPages();
	$pdf->AddPage();
	$pdf->SetFont("Helvetica", "", 7);
	
	$total_records=count($heatmap_points);
	$text="Mapped $total_records event(s).";
	$pdf->SetX($pdf->GetX()+4);
	$pdf->MultiCellTag(0, 6, $text, 0, "L", 0, 0, 0, 0, 0);
		
	// image
	$url="http://localhost/nagiosxi/reports/alertheatmap.php?".time();
	foreach($request as $var => $val)
		$url.="&".urlencode($var)."=".urlencode($val);
	$url.="&mode=image&width=".urlencode($width)."&height=".urlencode($height);
	// add authentication stuff
	$url.="&username=".$_SESSION["username"]."&ticket=".get_user_attr($uid,"backend_ticket");
	
	//echo "URL: $url<BR>";
	//exit;
	
	// get raw image
	$imgdata=file_get_contents($url);
	// create tmp file
	$temp=tempnam("/tmp","heatmap");
	//echo "TEMP FILE: $temp<BR>";
	// save image
	file_put_contents($temp,$imgdata);
	// rename file
	$imgfile=$temp.".png";
	rename($temp,$imgfile);
	//echo "IMGFILE=$imgfile<BR>";
	
	// we have to scale the image...
	$imgscale=170/$width;

	$pdf->Image($imgfile,$pdf->GetX(),$pdf->GetY()+5,$width*$imgscale,$height*$imgscale);

	// delete temp file
	unlink($temp);
	//exit;

	$pdf->Output("alertheatmap.pdf", "I");
	}

	
function get_heatmap_imagemap(){
	global $heatmap_points;
	
	$width=grab_request_var("width",500);
	$height=grab_request_var("height",400);
	$radius=grab_request_var("radius",12);

?>
	<map name="theheatmap">
<?php
	foreach($heatmap_points as $point){
		//$point["url"]="#";
		echo "<area href='".$point["url"]."' shape='circ' coords='".$point["x"].",".$point["y"].",".($radius*1.5)."' title='".$point["title"]."' />\n";
		//class=\"{stroke:false,fillColor:'ff0000',fillOpacity:0.6}\" 
		}
?>
	</map>
<?php
	}
	
	
function get_heatmap_data(){
	global $heatmap_points;
	
	// get values passed in GET/POST request
	$reportperiod=grab_request_var("reportperiod","last24hours");
	$startdate=grab_request_var("startdate","");
	$enddate=grab_request_var("enddate","");
	$search=grab_request_var("search","");
	$host=grab_request_var("host","");
	$service=grab_request_var("service","");
	$hostgroup=grab_request_var("hostgroup","");
	$servicegroup=grab_request_var("servicegroup","");
	
	$width=grab_request_var("width",500);
	$height=grab_request_var("height",400);
	$radius=grab_request_var("radius",12);
	
	// determine start/end times based on period
	get_times_from_report_timeperiod($reportperiod,$starttime,$endtime,$startdate,$enddate);


	// initialize data
	$heatmap_points=array();
	
	// sample data
	/*
	for($x=1;$x<10;$x++){
		add_heatmap_point(200+($x*3),100+($x*2),"point ".$x);
		}
	add_heatmap_point(50,50,"point a");
	add_heatmap_point(55,60,"point b");
	add_heatmap_point(100,200,"point c");
	*/
	
	$timediff=$endtime-$starttime;
	//echo "START=$starttime, END=$endtime<BR>";
	//echo "TIMEDIFF=$timediff<BR>";
	$timeradius=intval(($timediff/$width)*$radius);
	//echo "TIMERADIUS=$timeradius<BR>";
	
	$xml=get_statehistory_xml();
	//print_r($xml);
	if($xml){
		foreach($xml->stateentry as $se){
			$statetime=strval($se->state_time);
			$objectid=intval($se->object_id);
			$objecttype=intval($se->objecttype_id);
			$state=intval($se->state);
			
			$stt=strtotime($statetime);
			$offset=($stt-$starttime);
			
			$host=strval($se->host_name);
			$service=strval($se->service_description);
			
			$objectname=$host;
			if($service!="")
				$objectname.=" / ". $service;
				
			$statestr="";
			if($objecttype==OBJECTTYPE_HOST)
				$statestr=host_state_to_string($state);
			else
				$statestr=service_state_to_string($state);		
			
			$title=$objectname." ".$statestr." @ ".$statetime;
			
			$url=get_base_url()."/reports/statehistory.php?1";
			$url.="&host=".urlencode($host);
			$url.="&service=".urlencode($service);
			$url.="&search=".urlencode($search);
			$url.="&reportperiod=custom";
			$url.="&startdate=".($stt-$timeradius);
			$url.="&enddate=".($stt+$timeradius);
			
			add_heatmap_point($offset,$objectid,$title,$url);
			}
		}
		
	//print_r($heatmap_points);
		
	// scale data points
	scale_heatmap_data($width,$height);
	}

	
// this function gets the XML records of state history data for multiple
// output formats (CSV, PDF, HTML)
function get_statehistory_xml(){
	global $lstr;

	// get values passed in GET/POST request
	$reportperiod=grab_request_var("reportperiod","last24hours");
	$startdate=grab_request_var("startdate","");
	$enddate=grab_request_var("enddate","");
	$search=grab_request_var("search","");
	$host=grab_request_var("host","");
	$service=grab_request_var("service","");
	$hostgroup=grab_request_var("hostgroup","");
	$servicegroup=grab_request_var("servicegroup","");
	$statetype=grab_request_var("statetype","hard");
	
	// fix search
	if($search==$lstr['SearchBoxText'])
		$search="";
	
	// special "all" stuff
	if($hostgroup=="all")
		$hostgroup="";
	if($servicegroup=="all")
		$servicegroup="";
	if($host=="all")
		$host="";

	// can do hostgroup OR servicegroup OR host
	if($hostgroup!=""){
		$servicegroup="";
		$host="";
		}
	else if($servicegroup!=""){
		$host="";
		}

	//  limit hosts by hostgroup or host
	$host_ids=array();
	//  limit by hostgroup
	if($hostgroup!=""){
		$host_ids=get_hostgroup_member_ids($hostgroup);
		}
	//  limit by host
	//else if($host!=""){
	///	$host_ids[]=get_host_id($host);
	//	}
	//  limit service by servicegroup
	$service_ids=array();
	if($servicegroup!=""){
		$service_ids=get_servicegroup_member_ids($servicegroup);
		}
		
	$object_ids=array();
	$object_ids_str="";
	$y=0;
	foreach($host_ids as $hid){
		if($y>0)
			$object_ids_str.=",";
		$object_ids_str.=$hid;
		$y++;
		}
	foreach($service_ids as $sid){
		if($y>0)
			$object_ids_str.=",";
		$object_ids_str.=$sid;
		$y++;
		}
		

	// determine start/end times based on period
	get_times_from_report_timeperiod($reportperiod,$starttime,$endtime,$startdate,$enddate);
	
	// get XML data from backend - the most basic example
	// this will return all records (no paging), so it can be used for CSV export
	$args=array(
		"starttime" => $starttime,
		"endtime" => $endtime,
		);
	switch($statetype){
		case "soft":
			$args["state_type"]=0;
			break;
		case "hard":
			$args["state_type"]=1;
			break;
		default:
			break;
		}
	if($object_ids_str!="")
		$args["object_id"]="in:".$object_ids_str;
	else{
		if($host!="")
			$args["host_name"]=$host;
		if($service!="")
			$args["service_description"]=$service;
		}
	if($search){
		$args["output"]="lk:".$search;
		}
	//echo "ARGS=";
	//print_r($args);
	$xml=get_statehistory_data($args);
	return $xml;
	}
	
// this function gets state history data in XML format from the backend
function get_statehistory_data($args){

	$xml=get_xml_statehistory($args);
	
	return $xml;
	}
	
	
function add_heatmap_point($x,$y,$title="",$url=""){
	global $heatmap_points;
	
	$heatmap_points[]=array("x"=>$x,"y"=>$y,"title"=>$title,"url"=>$url);
	}
	
	
function scale_heatmap_data($width,$height,$margin=-1){
	global $heatmap_points;
	
	$mode=grab_request_var("mode","");
	$debug=false;
	
	$radius=grab_request_var("radius",12);	
	if($margin==-1)
		$margin=$radius;
	
	// get max values
	$max_x=0;
	$max_y=0;
	foreach($heatmap_points as $point){
		if($point["x"]>$max_x)
			$max_x=$point["x"];
		if($point["y"]>$max_y)
			$max_y=$point["y"];
		}
		
	// determine scaling factor
	if($max_x==0)
		$scale_x=1;
	else
		$scale_x=(($width-($margin*2))/$max_x);
	if($max_y==0)
		$scale_y=1;
	else
		$scale_y=(($height-($margin*2))/$max_y);
	
	if($debug==true){
		echo "WIDTH-MARGIN=".($width-($margin*2))."<BR>";
		echo "HEIGHT-MARGIN=".($height-($margin*2))."<BR>";
		echo "MAX X=$max_x, Y=$max_y<BR>";
		echo "SCALE X=$scale_x, Y=$scale_y<BR>";
		print_r($heatmap_points);
		echo "<BR>";
		}
		
	
	// scale values
	$newpoints=array();
	foreach($heatmap_points as $index => $point){
		if($debug==true){
			echo "INDEX $index =";
			print_r($point);
			echo "<BR>";
			}
		$point["x"]=intval(($point["x"]*$scale_x)+$margin);
		$point["y"]=intval(($point["y"]*$scale_y)+$margin);
		$newpoints[]=$point;
		}
	$heatmap_points=$newpoints;
	if($debug==true){
		print_r($heatmap_points);
		}
	}
	

function generate_heatmap_image(){
	global $heatmap_points;

	$width=grab_request_var("width",500);
	$height=grab_request_var("height",400);
	$maxval=grab_request_var("maxval",5);
	$radius=grab_request_var("radius",12);

	//get_heatmap_data();
	
	output_heatmap_image($heatmap_points,$width,$height,$maxval,$radius);
	}
	

function output_heatmap_image($points,$body_width=500,$body_height=400,$max_value=5,$radius=18){

	// create a new image
	$img=imagecreatetruecolor($body_width,$body_height);
	
	$c=array();
	$mag=array();

	// determine colors
	$color=array();
	$colors=$max_value*$radius;
	$c[0]=0;
	$c[1]=255;
	$c[2]=0;
	$c[3]=0;
	$add=2;
	$sub=0;
	$iterations=1275; // 1089 iterations for purple
	$iterationsPerColor=$iterations/$colors;
	$iteration=0;
	$colorIndex=0;
	
	while($iteration<$iterations){
	
		$c[$add]++;
		$c[$sub]--;
		
		if(($iteration % $iterationsPerColor)==0){
			$color[$colorIndex]=imagecolorallocate($img,$c[1],$c[2],$c[3]);
			$colorIndex++;
			}
			
		$iteration++;
		if(($iteration % 255)==0){
			if($c[1]==255 && $c[2]==255 && $c[3]==0){
				$add=0;
				$sub=1;
				} 
			// green
			elseif($c[1]==0 && $c[2]==255 && $c[3]==0){
				$add=3;
				$sub=0;
				} 
			elseif($c[1]==0 && $c[2] ==255 && $c[3]==255){
				$add=0;
				$sub=2;
				} 
			// blue
			elseif ($c[1]==0 && $c[2]==0 && $c[3]==255){
				$add=0;
				$sub=3;
				}
			}
		}
		
	// black background
	imagefill($img,1,1,$color[count($color)-1]);

	// pre-computations for color fadeout as we expand from center point out to radius
	$eq=array();
	for($d=0;$d<=$radius;$d++){
		$eq[$d]=(exp(-1*($d*$d)/50)*$radius);
		}

	// process each point
	// For info see http://patrickkonsor.com/projects/heatmap
	foreach($points as $point){
	
		// grab x/y coordinate
		$x=$point['x'];
		$y=$point['y'];
		
		// x values of "dot"...
		for($j=($x-$radius);$j<($x+$radius);$j++){
		
			// y values of "dot"...
			for($k=($y-$radius);$k<($y+$radius);$k++){
			
				// how far are we from the center of the dot?
				$d=round(sqrt(pow($j-$x,2)+pow($k-$y,2)));
				
				// if we're inside the radius, add some color...
				if($d <= $radius){
				
					// add array/slot if it doesn't exist
					if(!array_key_exists($j,$mag))
						$mag[$j]=array();
					if(!array_key_exists($k,$mag[$j]))
						$mag[$j][$k]=0;
				
					// deepness/intensity of color changes based on distance from center
					$mag[$j][$k]+=$eq[$d];
					
					// how deep of a color do we want?
					$l=$colors-$mag[$j][$k];
					if($l<0)
						$l=0;
						
					imagesetpixel($img,$j,$k,$color[$l]);
					}
				}
			}
		}
	
	header("Content-type: image/png");
	
	//imagepng($img, "heatmap.png");
	imagepng($img);
	}

?> 	

